      PROGRAM AIREPDEQC
C
C**** *AIRPROC*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING
C         AIREP DATA.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *AIRPROC*
C
C     METHOD.
C     -------
C
C          NONE.
C
C
C     EXTERNALS.
C     ----------
C
C        *CALL* *INITVAR( IERR )*
C        *CALL* *PROCRFB( IERR )*
C        *CALL* *PROCHDR( IERR )*
C        *CALL* *PROCTXT( IERR )*
C        *CALL* *PROCT1U( IERR )*
C
C     REFERENCE.
C     ----------
C
C          NONE.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA         *CPTEC*
c          ultima alteracao em 15.01.1999 
c                 nova SETTAB, correcao de numeros de subsets.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comrec.h'
      INCLUDE 'comstat.h'
c
      common /reperr/ numreperr
      common /recwriten/ irecswriten
      common /repetida/ irepetida
      common /inil/ inil
c
c
      character*15 cstop
C
C     ------------------------------------------------------------------
C*          1.   INITIALIZE VARIABLES AND CONSTANTS.
C                ----------------------------------
 100  CONTINUE
c
      numbullerr = 0
      numreperr = 0
      irecswriten = 0
c
C
      IERR=0
      CALL INITVAR( IERR )

C     ----------------------------------------------------------------
      OPEN(UNIT=99,FILE='airep.rdb',FORM='FORMATTED',
     1     STATUS='UNKNOWN',ACCESS='SEQUENTIAL',recordtype='stream')
C     ----------------------------------------------------------------
C           1.1  INITIALIZE MDB ACCESS.
C                ----------------------
 110  CONTINUE
C
C     ------------------------------------------------------------------
C*          2.   READ IN MESSAGE.
C                ----------------
 200  CONTINUE
c
      ierr = 0
      CALL READIN(IERR)
      IF(IERR.NE.0 .OR. IEOF.EQ.1) GO TO 1000
C     ------------------------------------------------------------------
C*          3.   FORMAT BULLETIN.
C                ----------------
 300  CONTINUE
C
      CALL PROCRFB( IERR )
c
      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(IERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          4.   DECODE BULLETIN HEADER.
C                -----------------------
 400  CONTINUE
C
      CALL PROCHDR( IERR )

      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C     ------------------------------------------------------------------
C*          5.   CHECK TEXT OF BULLETIN.
C                -----------------------
 500  CONTINUE
C
      CALL PROCTXT( IERR )

      if(ierr.ne.0) numbullerr = numbullerr + 1
c
      IF(KERR.NE.0) GO TO 200
C
C     ------------------------------------------------------------------
C*          6.   CALL APPROPRIATE ROUTINE TO DECODE AIRCRAFT DATA.
C                -------------------------------------------------
 600  CONTINUE
C
      CALL PROCT1U( IERR )
C
C
      GO TO 200
C
C     ------------------------------------------------------------------
C
c 1001 continue
c
c      print*,' Open error on AIRC.stop.dat'
c      go to 1000
c
c 1002 continue
c
c      print*,' Read error on AIRC.stop.dat'
c
 1000 CONTINUE
C
c     CALL MEBCLOSE()
c     CALL REBCLOSE()
c     CALL EBEXIT()
c
      close(unit=99)
c     
c----|-----------------------------------------------------------------|-------|
c               Criar uma estatistica do processamento das  
c               mensagens Serao incluida no arquivo cabecalho.dat.
c               
c             ________________________________________________
c             | VARIAVEL   |        DESCRICAO                |
C             |============|=================================|
c	      |	numbull    |   Numero de boletins lidos,     |
C             |------------|---------------------------------|
c             | numbullerr |   Numero de boletins com erro,  |
C             |------------|---------------------------------|
c             | numreport  |   Numero de mensagens lidas,    |
C             |------------|---------------------------------|
c	      |	numreperr  |   Numero de mensagens com erro, |
C             |------------|---------------------------------|
c    	      |	irecswriten|   Numero de mensagens gravadas, |
C             |------------|---------------------------------|
c	      |	irepetida  |   Numero de mensagens repetidas |
C             |------------|---------------------------------|
c             | inil       |   Numero de mensagens ignoradas |
c             |______________________________________________|
c               
c
c------------------------------------------------------------------------------
c       DECLARACAO DAS VARIAVEIS E ABERTURA DO ARQUIVO
c       
c----|-----------------------------------------------------------------|-------|
      numreport = 0
c
      do 15 i=1,26
         numreport = numreport + numrep(i)
 15   continue
c
      Open(91,file='mesg_err.dat',status='old',access='append')
c
      write(91,20)
      write(91,10)numbull,numbullerr,numreport,numreperr,
     c irecswriten,irepetida,inil
 10   format('| AIREP     |','     ',I5,'     |',
     c       '     ',I5,'    ||',I5,'     |'
     c       ,I5,'     |',I5,'     |',
     c       I5,'     |',I5,'     |')
      write(91,20)
 20   format('|-----------|---------------|------------',
     c        '--||----------|----------|----------|---',
     c        '-------|----------|')
c
c------------------------------------------------------------------------------
c

      close(91)
      close(76,disp='delete')
c
      stop
      END
      SUBROUTINE READIN( IERR )
C 
C**** *READIN*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO READ IN ONE BULLETIN AT A TIME.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *READIN( IERR )*
C
C
C
      IMPLICIT LOGICAL(L,O,G), CHARACTER*8(C,H,Y)
C
 
      CHARACTER*16384 YCHAR
      Character*16384 buff_aux
      Character*4 four_chars
      Character*4 endmsg
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comstat.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
C
      DATA NSKIP/0/
      Data aux/'0D0D0103'Z/       ! ^C^A^M^M (separador de mensagens)
C
 
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR= 0
      NWPT= 1
      NBPT= 0
      NSUB= 0
C
C*          1.1  READ IN BULLETIN AND INCERMENT BULLETIN COUNTER.
C                ------------------------------------------------
C
      IERR=0
C
      OPEN(UNIT=3,IOSTAT=IOS,ERR=400,
     1     FILE='airep.dat',
     1     STATUS='OLD')
 
C
      Write(endmsg,10) aux     ! ^C^A^M^M (separador de mensagens)
 10   Format(a4)
 110  CONTINUE
      index = 1
      ilen = 1
c     ychar(ilen:ilen) = char(0)   !  Inicializo p/ nao pegar lixo
      four_chars = char(0) // char(0) // char(0) // char(0)
c     
      Do While(four_chars .ne. endmsg)
      READ (3,'(Q,A)',ERR=200,END=300,IOSTAT=IOS) ILEN,YCHAR
      buff_aux(index:index+ilen-1) = ychar(1:ilen)
c     ------------------------------------------------------------------
c      Alteracao (Gamb) para cobrir problema do fortran v3.8. 
c       Na leitura do arquivo stream_LF,tem como final de registro um LF e CR,
c       sendo que este ultimo faz parte da mensagem, e por isso foi novamente 
c       acrescentado. 
c
c            A T E N C A O - checar as novas versoes do fortran/OSF.
c
c                    Rosangela.  04.07.96
c     ------------------------------------------------------------------
      index = index + ilen
      ilen = ilen + 1
      buff_aux(index:index) = char(13)  ! O CR nao vem na leitura
      ychar(ilen:ilen) = char(13)
      four_chars = ychar(ilen-3:ilen)
      end do
c
      ilen = index - 1
      ychar(1:ilen) = buff_aux(1:ilen)
c
C
      if(ilen.gt.4) NUMBULL=NUMBULL + 1
C
C*          1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
C      WRITE(*,9902) NUMBULL
C
C*          1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
      IF(NUMBULL.LE.NSKIP) GO TO 100
C
C*          1.4  TRANSFER BULLETIN TO 'KCHAR', ONE CHARACTER PER WORD
C                -----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C
      RETURN
C     -----------------------------------------------------------------
 200  CONTINUE
C
      IERR=1
      WRITE(*,9901) IOS
      PRINT*,'READIN: ILEN=',ILEN
      RETURN
C     -----------------------------------------------------------------
 300  CONTINUE
C
      IEOF=1
      PRINT*,'READIN: END OF FILE IEOF=',IEOF
      RETURN
C     -----------------------------------------------------------------
 400  CONTINUE
C
      IERR=1
      WRITE(*,9903) IOS
      RETURN
C     ----------------------------------------------------------------
 9901 FORMAT(1H0,'+ + + ERROR IN READING BULLETIN FILE. IOSTAT=',
     C I6,' DECIMAL')
 9902 FORMAT(1H ,'BULLETIN NUMBER IS ',I6)
 9903 FORMAT(1H0,'+ + + ERROR IN OPENING UNIT 3. IOSTAT=',
     C I6,' DECIMAL')
C     ----------------------------------------------------------------
      END
      SUBROUTINE PROCRFB ( IERR )
C**** *PROCRFB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO FORMAT BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCRFB(IERR)*
C
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C     ------------------------------------------------------------------
C*          1.   KEEP SOURCE OF DATA AND DATE/TIME OF ARRIVAL.
C                ---------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,3
C
      KHEAD(I)=MINDIC      ! THIS WILL BE CHANGED ACCORDING TO THE KEY.
C
 101  CONTINUE
C     ------------------------------------------------------------------
C*          2.  DEFINE T1 AND T2 FROM ABBREVIATED HEADING.
C               ------------------------------------------
 200  CONTINUE

      DO 202 I=1,ILEN
C
      IF(KCHAR(I).GE.65.AND.KCHAR(I).LE.90) GO TO 203
C
 202  CONTINUE
C
      IT1=27
      GO TO 210
C
 203  CONTINUE
C
      IT1=KCHAR(I  )-64
      IT2=KCHAR(I+1)-64
C
      IF(IT1.NE.21) THEN
                       IERR=1
                       IT1=27
                       RETURN
                    END IF
C
C     CHECK IF 'T2' CHARACTER IS LETTER.
C
      IF(IT2.LT.0.OR.IT2.GT.26) IT1=27
C
C*          2.1  LAST CHARACTER OF BULLETIN CAN BE IN ANY OF THE LAST
C                -----------------------------------------------------
C                5 WORDS. IF CHARACTER  IS 'ETX' REPLACE BY 'GS' .
C                -------------------------------------------------
C                IF NEITHER CAN BE FOUND INSERT 'GS' AS LAST CHARACTER.
C                ------------------------------------------------------
 210  CONTINUE
C
      IST=ILEN-5
C
      DO 211 I=1,ILEN
C
      IF (KCHAR(I).EQ.3.OR.KCHAR(I).EQ.29) THEN
                                              KCHAR(I)= 29
                                              IGS=I
                                              RETURN
                                           END IF
C
 211  CONTINUE
C
      I=I-1
      KCHAR(I)= 29
      IGS=I
C
      RETURN
      END
      SUBROUTINE PROCTXT ( IERR )
C
C**** *PROCTXT*
C
C
C     PURPOSE.
C     --------
C          CHECKS WHETHER BULLETIN CONTAINS USEFUL DATA .
C          THE FOLLOWING BULLETINS ARE CONSIDERED TO CONTAIN
C          NO USEFUL DATA.
C                 1. TEXT OF 'NIL' , OR VARIANTS OF THIS.
C                 2. TEXT OF 'NO DATA AVAILABLE'.
C                 3. TEXT OF 'NO REPORTS AVAILABLE'.
C                      1. - 3.  ARE DETERMINED SIMPLY BY CHECKING
C                      THE LENGTH OF THE TEXT . IF IT IS LESS
C                      THAN 26 THERE CANT BE ANY USEFUL DATA IN IT
C                 4. UK AND GERMAN DOMESTIC BULLETINS WHICH DO
C                    NOT CONFORM TO WMO CODES.
C
C          INPUT     : BULLETIN IN ARRAY 'KCHAR' ,
C                      ONE CHARACTER PER WORD.
C
C          OUTPUT    : KERR = 0 INDICATES BULLETIN CONTENTS REQUIRED.
C                           = 1 MEANS TEXT OF 'NIL' ETC.
C                           = 2 UK OR GERMAN DOMESTIC BULLETIN.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCTXT(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *savbull(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C          J. HENNESSY         *ECMWF*
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'combuff.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR.
C                ----------------------
 100  CONTINUE
C
      KERR= 0
C
C
C*          1.1  CHECK IF BULLETIN IS TOO SHORT I.E. 'NIL' BULLETIN.
C                ---------------------------------------------------
 110  CONTINUE
C
      ILE = IGS - IMI
      IF(ILE .LT. 26) THEN
                         KERR = 7
                         NUMBERR(7) = NUMBERR(7) + 1
                                KCHAR(IGS)=KCHAR(IGS).OR.128
C                               GO TO 900
                      END IF
C
C
C*          1.2  CHECK IF THE BULLETIN IS DOMESTIC FROM UK OR GERMANY.
C                -----------------------------------------------------
C                THIS IS DONE BY CHECKING IF THE BULLETIN HAS
C                --------------------------------------------
C                CCCC OF (EG--,ED--) OTHER THAN (EGRR,EDZW).
C                -------------------------------------------
 120  CONTINUE
C
      IPT=IAH+4
      CALL NEXTLET(IPT,JAH)
C
C     IF BULLETINS HAVE 'CCCC' NOT 'ED--' OR 'EG--' , RETURN.
C
      IF ( KCHAR(IPT).NE.69 ) RETURN
      IF ( KCHAR(IPT+1).NE.71.AND.KCHAR(IPT+1).NE.68 ) RETURN
C
C        FIRST UK
C
             IF (KCHAR(IPT+1).EQ.71)
     C                      THEN
                                 IF(KCHAR(IPT+2) .NE. 82 .OR.
     1                              KCHAR(IPT+3) .NE. 82)
     2                                   KERR = 8
                            ELSE
C
C        THEN GERMANY
C
                                 IF(KCHAR(IPT+2) .NE. 90 .OR.
     1                              KCHAR(IPT+3) .NE. 87)
     2                                   KERR = 8
                            END IF
C
C     MARK CCCC GROUP IF REQUIRED.
C
      IF ( KERR.EQ.8 ) THEN
                              KCHAR(IPT+4) = KCHAR(IPT+4).OR.128
                              NUMBERR(8) = NUMBERR(8) + 1
                          END IF
C
C           1.3 TREAT IN ACCORDANCE WITH DEFINED OPTIONS.
C               -----------------------------------------
 130  CONTINUE
C
C     RETURN IF NO ERROR.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
 900  CONTINUE
C
      N = KERR - 1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C           1.4  PRINT BULLETIN IF REQUIRED.
C                ---------------------------
 140  CONTINUE
C
      IF (N1.EQ.1) THEN
                       WRITE (*,9900) KERR
                       CALL PRTBULL (1,IGS)
                   END IF
C
C           1.5 WRITE TO ERROR FILE IF REQUIRED.
C               --------------------------------
 150  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
      RETURN
C     -----------------------------------------------------------------
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C     -----------------------------------------------------------------
      END
      SUBROUTINE PROCHDR ( IERR )
C
C**** *PROCHDR
C
C
C     PURPOSE.
C     --------
C         DEODE BULLETIN HEADER AND INSERT REQUIRED PARAMETERS
C         IN DECODED REPORT HEADER.
C
C         LOCATES BEGINNING  AND END OF ABBREVIATED HEADER AND
C         'MIMIMJMJ' LINES.
C
C         INPUT     : BULLETIN IN KCHAR(1) - KCHAR(IGS)
C
C                     BULLETIN RECORD HEADER IN KINT(1) - KINT(5)
C
C                     'IT1' = 27 INDICATING BULLETIN HAS NOT BEEN
C                            IDENTIFIED FROM 'TT' OF ABBREVIATED HEADER.
C
C         OUTPUT    : KDEC(10) = DAY OF MONTH ( INTEGER ) . YY
C                     KDEC(11) = TIME OF BULLETIN - HOURS ( INTEGER ) . G
C                     KDEC(12) = TIME OF BULLETIN - MINS ( INTEGER ) . GG
C
C                     KDEC(14) = 0 IF ORIGIN OF REPORT IS FGGE.
C                                1  "   "     "    "    " BRACKNELL.
C                                2  "   "     "    "    " OFFENBACH.
C
C                     KDEC(20) =1 NIL
C                     KDEC(21) =1 IF BULLETIN IS 'COR' , OTHERWISE
C                                    = 0 .
C
C                     KDEC(21) = 1 IF BULLERIN IS 'CCA'
C                     KDEC(21) = 2 IF BULLERIN IS 'CCB'
C                     KDEC(21) = 3 IF BULLERIN IS 'CCC'
C                     KDEC(21) = 4 IF BULLERIN IS 'CCD'
C                     .
C                     .
C
C                     KDEC(18) = DATE OF BULLETIN ARRIVAL ( ON VAX )
C                     KDEC(19) = TIME  "    "        "      "     "
C
C                     IAH =    "      " BEGINNING OF 'ABBREVIATED HEADER'
C                     JAH =    "      "     END   "       "         "
C
C                     IMI =    "      " BEGINNING OF 'MIMIMJMJ' LINE.
C                     JMI =    "      "     END   "       "       "
C
C                     KERR = 0 IF NO ERROR FATAL TO DECODING ENCOUNTERED.
C                         = 1 IF BULLETIN HAS LESS THAN 3 LINES.
C                         = 2 IF BULLETIN IS NOT RECOGNISED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCHDR( IERR )*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C         *CALL* *NEXTFIG(I,J)*
C         *CALL* *EXTGRP (I,N1,N2,N3,N4,N5,N,IRET)*
C         *CALL* *NEXTLET(I,J)*
C         *CALL* *SAVBULL(IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C          J. HENNESSY         *ECMWF*
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
C
      DIMENSION ILST(26)
      DATA ILST/65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,80,
     1          81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C
C*          1.   CLEAR ERROR INDICATOR AND SET REPORT HEADER AREA
C                ------------------------------------------------
C                TO MISSING DATA INDICATOR.
C                --------------------------
 100  CONTINUE
C
      KERR=0
C
      DO 101 I=1,24
C
      KDEC(I)= MINDIC
C
 101  CONTINUE
C
C*          1.1  FLAG FIELDS SET TO ZERO.
C                ------------------------
 110  CONTINUE
C
      KDEC(13)=0
      KDEC(15)=0
      KDEC(21)=0
C
C*          2.  LOCATE BEGINNING AND END OF 'STARTING LINE' ,
C               ---------------------------------------------
C               'ABBREVIATED HEADER' AND 'MIMIMJMJ LINE ' .
C               -------------------------------------------
C
      ISL = 1
      CALL NEXTPRT ( ISL,IGS )
      JSL = ISL
      CALL NEXTEND ( JSL,IGS )
      IAH = JSL
      CALL NEXTPRT ( IAH,IGS ) 
      JAH =IAH
      CALL NEXTEND ( JAH,IGS )
      IMI = JAH
      CALL NEXTPRT ( IMI,IGS )
      JMI = IMI
      CALL NEXTEND ( JMI,IGS )
C
C*          2.1 IF THESE 3 LINES CANNOT BE LOCATED , BULLETIN CONSISTS
C               ------------------------------------------------------
C               OF LESS THAN 3 LINES.
C               ---------------------
 210  CONTINUE
C
      IF ( JMI.GT.IGS ) THEN
C
C                           SET ERROR NUMBER AND MARK ERROR.
C
                            KERR = 1
                            KCHAR(IGS)=KCHAR(IGS).OR.128
                            NUMBERR(1) = NUMBERR(1) + 1
                            GO TO 300
                        END IF
C
C
C
C*          2.2  BULLETIN CANNOT BE IDENTIFIED FROM 'TT' .
C                -----------------------------------------
 220  CONTINUE
C
      IF ( IT1.EQ.27 ) THEN
C
C                          SET ERROR NUMBER AND MARK ERROR.
C
                           KERR = 2
                           KCHAR(IAH+2)=KCHAR(IAH+2).OR.128
                           NUMBERR(2) = NUMBERR(2) + 1
                           GO TO 300
                       END IF
C
C
C*          2.3  NO CHECKS ARE MADE ON TTAAII OR CCCC GROUPS.
C                --------------------------------------------
 230  CONTINUE
C
C
C
C*          2.4  LOCATE AND DECODE 'YYGGGG' GROUP .
C                ----------------------------------
 240  CONTINUE
C
C     SCAN 'KCHAR' FOR FIRST FIGURE AFTER 'II' FIGURES.
C
      IPT = IAH + 6
      CALL NEXTFIG ( IPT,JAH )
      IF ( IPT.GE.JAH ) THEN
                          KERR = 2
                        ELSE
C
C                         EXTRACT YY,GG AND GG AND CONVERT TO INTEGERS
C                         IN WORDS 10-12 OF 'KINT' .
C
                          CALL EXTGRP( IPT,2,2,2,0,0,10,IRET )
                          IPT = IABS(IPT)
C
C                         TEST VALIDITY OF YY,GG AND GG.
C                         THIS TEST MAKES CHECKING RETURN CODE 'IRET'
C                         UNNECESSARY.
C
                          IF ( KINT(10).LT.1.OR.KINT(10).GT.31 )
     C                             THEN
                                        KERR = 2
                                        KINT(10) = MINDIC
                                   END IF
C
                          IF ( KINT(11).LT.0.OR.KINT(11).GT.23 )
     C                             THEN
                                        KERR = 2
                                        KINT(11) = MINDIC
                                   END IF
C
                          IF ( KINT(12).LT.0.OR.KINT(12).GT.59 )
     C                             THEN
                                        KERR = 2
                                        KINT(12) = MINDIC
                                   END IF
C
C
C                                  COPY TO DECODED REPORT HEADER AREA
C                                  AND RESET WORDS IN 'KINT'.
C
                                   DO 241 I=10,12
                                          KDEC(I) = KINT(I)
                                          KINT(I) = MINDIC
  241                              CONTINUE
C
                        END IF
C
C     MARK ERROR IN YYGGGG GROUP.
C
      IF ( KERR.EQ.2 ) THEN
                              KCHAR(IPT)=KCHAR(IPT).OR.128
                              NUMBERR(5) = NUMBERR(5) + 1
                          END IF
C
C
C
C
C*          2.5 THE ONLY CHECK ON 'BBB' IS FOR 'COR'.
C               -------------------------------------
 250  CONTINUE
C
C     FIND NEXT LETTER IN ABBREVIATED HEADER LINE AND CHECK IF 'C' (67)
C
C      CALL PRTBULL(1,IGS)
      CALL NEXTLET ( IPT,JAH )
C
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.79) THEN
                                                       KDEC(21)=1
                                                       GO TO 260
                                                    END IF
      IF ( KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.67)
     1     THEN
              DO 251 IJ=1,26
              IF(KCHAR(IPT+2).EQ.ILST(IJ)) THEN
                                              KDEC(21)=IJ
                                              GO TO 260
                                           END IF
C
 251          CONTINUE
C
           END IF
C
C
C
C*          2.6 INSERT ORIGIN AND DATE/TIME OF ARRIVAL OF BULLETIN.
C               ---------------------------------------------------
 260  CONTINUE
C
C     ORIGIN IS DERIVED FROM KEY . BRACKNELL FILE
C     NAMES START WITH 'B' AND OFFENBACH WITH 'C'. THIS FILENAME IS
C     IN ASCCI CODE       ( 'B' =66 , 'C' = 67)
C
      KDEC(14) = MINDIC    !    ORIGIN WILL BE DEFINED FROM KEY.
C
C
      KDEC(18) = MINDIC               ! DATE AND TIME OF ARRIVAL
      KDEC(19) = MINDIC               !
C
C
C
C*          2.7 TREAT ERROR BULLETIN IN ACCORDANCE WITH DEFINED OPTIONS.
C               --------------------------------------------------------
 270  CONTINUE
C
C     RETURN IF NO ERRORS FOUND.
C
      IF ( KERR.EQ.0 ) RETURN
C
C
C*          3. HANDLE ERROR BULLETIN.
C              ----------------------
 300  CONTINUE
C
      N = KERR-1
      N1 =JISHFT(IOPTS(677),-N).AND.1
      N2 =JISHFT(IOPTS(678),-N).AND.1
C
C*          3.1 PRINT BULLETIN IF REQUIRED.
C               ---------------------------
 310  CONTINUE
C
      IF ( N1.EQ.1 ) THEN
                         WRITE (*,9900) KERR
                         CALL PRTBULL ( 1,IGS)
                     END IF
C
C*          3.2 WRITE BULLETIN TO ERROR FILE IF REQUIRED.
C               -----------------------------------------
 320  CONTINUE
C
      IF ( N2.EQ.1 ) CALL SAVBULL(IERR)
C
C*          3.3  ONLY ERRORS 1 AND 2 ARE FATAL TO DECODING , SO CLEAR
C                -----------------------------------------------------
C                ERROR INDICATOR BEFORE RETURNING.
C                ---------------------------------
 330  CONTINUE

c     IF ( KERR.GT.2 ) KERR = 0
      if (kerr.gt.2) then
         kerr = 0
c        ierr = 0
      end if
c
C
C
      RETURN
C
C
 9900 FORMAT (1H ,'BULLETIN ERROR NUMBER ',I2.2)
C
C
      END
      SUBROUTINE PROCT1U ( IERR )
C
C**** *PROCT1U*
C
C
C     PURPOSE.
C     --------
C         CONTROLLING ROUTINE FOR DECODING UPPER AIR
C         DATA ( BULLETINS WITH 'T1' OF 'U' )
C
C         INPUT    : IERR IS NOT USED ON INPUT.
C
C                    IT2  = 1-26 CORRESPONDING TO 'T2' OF A-Z.
C
C         OUTPUT   : IERR IS UNALTERED UNLESS A FATAL ERROR OCCURRS ,
C                     WHEN IT IS SET TO 1.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PROCT1U(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *BULLUA(IERR)*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  CALL APPROPRIATE ROUTINE, 'IT2' CONTAINS AN INTEGER IN THE
C                ---------------------------------------------------------
C               RANGE 1-26, CORRESPONDING TO 'T2' OF ABBREVIATED HEADER.
C                -------------------------------------------------------
 100  CONTINUE
C
C
      GOTO ( 110,120,130,140,150,160,170,180,190,200,210,220,230,
     C       240,250,260,270,280,290,300,310,320,330,340,350,360) IT2
C
C     -----------------------------------------------------------------
C*              1.1  BULLETINS WITH 'TT' = 'UA'.  AIRCRAFT REPORTS.
C                    ----------------------------------------------
 110  CONTINUE
      CALL BULLUA ( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              1.2  BULLETINS WITH 'TT' = 'UB'.
C                    ---------------------------
 120  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.3  BULLETINS WITH 'TT' = 'UC'.
C                    ---------------------------
  130 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.4  BULLETINS WITH 'TT' = 'UD'.
C                    ---------------------------
  140 CONTINUE
      CALL BULLUA ( IERR )
      RETURN
C     -----------------------------------------------------------------
C*              1.5  BULLETINS WITH 'TT' = 'UE'.
C                    ----------------------------
  150 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.6  BULLETINS WITH 'TT' = 'UF'.
C                    ---------------------------
  160 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.7  BULLETINS WITH 'TT' = 'UG'.
C                    ----------------------------
  170 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.8  BULLETINS WITH 'TT' = 'UH'.
C                    ---------------------------
  180 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              1.9  BULLETINS WITH 'TT' = 'UI'.
C
  190 CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.0  BULLETINS WITH 'TT' = 'UJ'.
C                    ---------------------------
 200  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.1  BULLETINS WITH 'TT' = 'UK'.
C                    ---------------------------
 210  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.2  BULLETINS WITH 'TT' = 'UL'.
C                    ---------------------------
 220  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.3  BULLETINS WITH 'TT' = 'UM'.
C                    ---------------------------
 230  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.4  BULLETINS WITH 'TT' = 'UN'.
C                    ---------------------------
 240  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.5  BULLETINS WITH 'TT' = 'UO'.
C                    ---------------------------
 250  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.6  BULLETINS WITH 'TT' = 'UP'.
C                    ---------------------------
 260  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.7  BULLETINS WITH 'TT' = 'UQ'.
C                    ---------------------------
 270  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.8  BULLETINS WITH 'TT' = 'UR'.
C                    ---------------------------
 280  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              2.9  BULLETINS WITH 'TT' = 'US'.
C                    ---------------------------
 290  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.0  BULLETINS WITH 'TT' = 'UT'.
C                    ---------------------------
 300  CONTINUE
      RETURN
C     -----------------------------------------------------------------
C*              3.1  BULLETINS WITH 'TT' = 'UU'.
C
 310  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.2  BULLETINS WITH 'TT' = 'UV'.
C
 320  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.3  BULLETINS WITH 'TT' = 'UW'.
C
 330  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.4  BULLETINS WITH 'TT' = 'UX'.
C
 340  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.5  BULLETINS WITH 'TT' = 'UY'.
C
 350  CONTINUE
      RETURN
C     ------------------------------------------------------------------
C*              3.6  BULLETINS WITH 'TT' = 'UZ'.
C
 360  CONTINUE
      RETURN
C
C
      END
      SUBROUTINE BULLUA ( IERR )
C
C**** *BULLUA*
C
C
C     PURPOSE.
C     --------
C
C         CONTROLLING ROUTINE FOR DECODING OF INDIVIDUAL
C         REPORTS FROM BULLETINS OF AIRCRAFT OBSERVATIONS
C
C         INPUT         : BULLETIN IN CCITT 5 CHARACTERS , 1 CHARACTER
C                         PER WORD IN 'KCHAR'.
C
C                         POINTERS TO BEGINNING AND END OF 'STARTING LINE',
C                         'ABBREVIATED HEADING','MIMIMJMJ LINE' AND END
C                         OF BULLETIN.
C
C                         IERR NOT USED.
C
C         OUTPUT        : DECODED REPORTS WRITTEN TO FILE AND ERROR
C                         REPORTS TO ERROR FILE.
C
C                         IERR = 1 , IF ANY FILE HANDLING ERROR.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BULLUA(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *SAVREP(IHEAD,IERR)*           
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comair.h'
c
      common /reperr/ numreperr
      common /inil/inil
C
C     ------------------------------------------------------------------
C*          1.   PRINT INPUT BULLETIN OF AIRCRAFT REPORT.
C                ----------------------------------------
 100  CONTINUE
C
c      CALL PRTBULL (1,IGS)
C
C
C     ------------------------------------------------------------------
C*          1.1  SET FLAGS AND WORKING POINTER.
C                ------------------------------
 110  CONTINUE
C
C     WORKING POINTER SET TO POINT TO FIRST LETTER OF MIMIMJMJ
C     GROUP.
C
      IPT = IMI
C
C     CLEAR FLAG WHICH INDICATES BULLETIN HEADER ALREADY WRITTEN TO
C     ERROR FILE.
C
      IHEAD = 0
C
C
C     ------------------------------------------------------------------
C*          1.2 HANDLE MIMIMJMJ LINE . SET DATA BASE CODE TYPE INDICATOR
C               --------------------------------------------------------
C              IN DECODED REPORT HEADER AND LOCATE START OF FIRST REPORT.
C              ----------------------------------------------------------
C              CODE TYPE INDICATOR IS 141 FOR AIREPS.
C              --------------------------------------
 120  CONTINUE
C
      KDEC(4) = 141
      IF(IT1.EQ.21.AND.IT2.EQ.4) KDEC(4)= 144
C
C
C     MIMIMJMJ MAY BE 'ARP','AIREP' OR 'ARS' . THE MIMIMJMJ LINE
C     IS ALSO FREQUENTLY OMITTED.
C
C     SET K1 TO POINT TO THE NEXT 'SPACE' CHARACTER.
C
      K1 = IPT
      CALL NEXTVAL ( K1,32,IGS )
C
C     SET K2 TO POINT TO THE NEXT 'CR' CHARACTER.
C
      K2 = IPT
      CALL NEXTEND ( K2,IGS )
C
C      IF A 'CR' CHARACTER IS FOUND BEFORE 'SPACE',REPORT STARTS
C      ON NEXT LINE.
C
      IF ( K2.LT.K1 )
     C    THEN
              IPT = K2
          END IF
      CALL NEXTPRT (IPT,IGS)
C
C     VERY FREQUENTLY THE MIMIMJMJ GROUP IS INCLUDED AT THE START
C     OF EACH REPORT . IF THIS IS THE CASE SKIP TO NEXT GROUP.
C
  121 ISMIMJ = 0
      NPHASE = 999999
      ierr=0
C
C     ARP
C
      IF ( KCHAR(IPT).EQ.65.AND.KCHAR(IPT+1).EQ.82.AND.KCHAR(IPT+2)
     C    .EQ.80 ) ISMIMJ = 1
C
C     ARS
C
      IF ( KCHAR(IPT).EQ.65.AND.KCHAR(IPT+1).EQ.82.AND.KCHAR(IPT+2)
     C    .EQ.83 ) ISMIMJ = 1
C
C     AIR
C
      IF ( KCHAR(IPT).EQ.65.AND.KCHAR(IPT+1).EQ.73.AND.KCHAR(IPT+2)
     C    .EQ.82 ) ISMIMJ = 1
C
C     LVR
C
      IF ( KCHAR(IPT).EQ.76.AND.KCHAR(IPT+1).EQ.86.AND.KCHAR(IPT+2)
     C    .EQ.82 ) THEN
          ISMIMJ = 1
          NPHASE = 3
      END IF
C
C     ASC
C
      IF ( KCHAR(IPT).EQ.65.AND.KCHAR(IPT+1).EQ.83.AND.KCHAR(IPT+2)
     C    .EQ.67 ) THEN
          ISMIMJ = 1
          NPHASE = 5
      END IF
C
C     DES
C
      IF ( KCHAR(IPT).EQ.68.AND.KCHAR(IPT+1).EQ.69.AND.KCHAR(IPT+2)
     C    .EQ.83 ) THEN
          ISMIMJ = 1
          NPHASE = 6
      END IF
C
C     LVW
C
      IF ( KCHAR(IPT).EQ.76.AND.KCHAR(IPT+1).EQ.86.AND.KCHAR(IPT+2)
     C    .EQ.87 ) THEN
          ISMIMJ = 1
          NPHASE = 4
      END IF
C
C     ///
C
      IF ( KCHAR(IPT).EQ.47.AND.KCHAR(IPT+1).EQ.47.AND.KCHAR(IPT+2)
     C    .EQ.47 ) THEN
          IF(KCHAR(IPT+3).NE.32) THEN
             IPT=IPT+3
             GO TO 130
          END IF
          ISMIMJ = 1
          NPHASE = 999999
      END IF
C
      IF ( ISMIMJ.EQ.1 ) THEN
                             CALL NEXTVAL (IPT,32,IGS)
                             CALL NEXTPRT (IPT,IGS)
                         END IF
C
C
C     -------------------------------------------------------------------
C*              1.3 LOCATE END OF REPORT (=) AND INCREMENT REPORT COUNTER.
C                   ------------------------------------------------------
c                   if = sign is missing try to find next mimimjmj.
c                   ------------------------------------------------ 
 130  CONTINUE
C
      IEQ = IPT
      CALL NEXTEQ ( IEQ,IGS )
      IF(IEQ.GT.IGS) THEN
          PRINT*,' = SIGN MISSING AT THE END OF REPORT '
      END IF
C
C     TRY TO FIND NEXT MIMJ GROUP
C
      CALL NXMIMJ(IPT,IEQ,IIPT)
      IF(IIPT.LT.IEQ) IEQ=IIPT
          
C
      NUMREP(2) = NUMREP(2) + 1
C
C
C     --------------------------------------------------------------------
C*               2.  DECODE REPORT.
C                    ---------------
 200  CONTINUE
C
C                2.1 CONVERT REPORT TO INTERMEDIATE FORMAT.
C                    --------------------------------------
 210  CONTINUE
C
      CALL UAINT ( IHEAD,IERR )

      isaverr = ierr
       if (kerr .eq. 1 .or. kerr .eq. 2) inil = inil + 1
C
      IF (KERR.NE.0 ) GO TO 230
C
C
C*               2.2 CONVERT INTERMEDIATE TO DECODED FORMAT AND
C                    ------------------------------------------
C                    WRITE TO FILE.
C                    ---------------
 220  CONTINUE
C
      CALL UADEC ( IHEAD,IERR )
c
      isaverr = ierr
C
      IF ( KERR.NE.0 ) GO TO 230
C
C*               2.3  LOCATE START OF NEXT REPORT.
C                     ----------------------------
 230  CONTINUE
C
c
      if (isaverr.ne.0) numreperr = numreperr + 1
      isaverr = 0
      kerr = 0
      ierr = 0
c
      IPT = IEQ + 1
      call nextsep  ( ipt,igs)
      CALL NEXTPRT ( IPT,IGS )
C
C*               2.4  CHECK FOR END OF BULLETIN.
C                     ---------------------------
 240  CONTINUE
C
      IF (IPT.GT.IGS)
     C    THEN
C
C             END OF BULLETIN , SO IF ANY REPORT HAS BEEN WRITTEN TO
C             THE ERROR FILE , ADD 'GS' CHARACTER BEFORE RETURNING.
C
              IF ( IHEAD.EQ.0 ) RETURN
              IHEAD = 2
              CALL SAVREP( IHEAD,IERR )
              RETURN
          END IF
C
C
C
C*               2.5 GO TO NEXT REPORT.
C                    ------------------
 250  CONTINUE
C
      GO TO 121
C
C
      END
      SUBROUTINE UAINT ( IHEAD,IERR )
C
C**** *UAINT*
C
C
C     PURPOSE.
C     --------
C
C         CONVERT AIRCRAFT REPORTS FROM CCITT 5 CHARACTER
C         FORMAT TO INTERMEDIATE ( INTEGER ) FORMAT.
C
C         INPUT      : REPORT IN KCHAR(IPT) - KCHAR(IEQ) , IN CCITT 5 ,
C                      1 CHARACTER PER WORD.
C
C                      IHEAD = 0 INDICATES BULLETIN HEADER NOT ALREADY
C                                WRITTEN TO ERROR FILE.
C                            = 1 MEANS HEADER ALREADY WRITTEN TO ERROR FILE.
C
C                       IERR IS NOT USED ON INPUT.
C
C          OUTPUT     : REPORT IN INTEGER FORMAT IN ARRAY 'KINT' IN
C                       DESIRED FORMAT ( SEE SEPARATE DOCUMENTATION)
C
C                       IERR = 1 IF ANY FILE HANDLING ERROR ENCOUNTERED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UAINT(IHEAD,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PRTBULL(I,J)*
C         *CALL* *NEXTVAL(I,J)*
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *EXTINT(I,J)*
C         *CALL* *EXTGRP(I,J)*
C         *CALL* *NEXTFIG(I,J)*
C         *CALL* *FIXUA*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comident.h'
C
      CHARACTER*10 YLOCAT(195),YLOC
C
      DIMENSION ILAT(195) ,ILONG(195), ILOC(10)
C
      DATA NDEF /195 /
C
C
C
      DATA (YLOCAT(I),I=1,60) /
     C    'OTBON'    ,   'EMRAX'    ,   'LENBA'    ,   'NTN'      ,
     C    'URDOG'    ,   'TAM'      ,   'VAMPI'    ,   'SANBI'    ,
     C    'TURLI'    ,   'AMMI'     ,   'SANOK'    ,   'TATIL'    ,
     C    'APCR'     ,   'ABRK'     ,   'DOLIM'    ,   'BIGIL'    ,
     C    'REOLA'    ,   'POMAS'    ,   'ANIVI'    ,   'KALUG'    ,
     C    'LANAG'    ,   'GUPLA'    ,   'PADPA'    ,   'MDG'      ,
     C    'ADGV'     ,   'MCO'      ,   'MANTA'    ,   'BUVLA'    ,
     C    'SAMON'    ,   'CMU'      ,   'SUKAR'    ,   'AHDB'     ,
     C    'KANTO'    ,   'PATKA'    ,   'KIBAG'    ,   'TAPON'    ,
     C    'LEKAT'    ,   'LAMOB'    ,   'UNTOK'    ,   'SAPDA'    ,
     C    'OLENG'    ,   'LAMEP'    ,   'ANIVI'    ,   'SEBRI'    ,
     C    'ELBAR'    ,   'PATLA'    ,   'ADPER'    ,   'TAPOK'    ,
     C    'PALTI'    ,   'OPABA'    ,   'PEARL'    ,   'RULSA'    ,
     C    'ALFA'     ,   'OYST'     ,   'REMOVED'  ,   'LOACH'    ,
     C    'PKS'      ,   'CYYT'     ,   'CYQX'     ,   'GULGO'    /
C
      DATA (YLOCAT(I),I=61,120) /
     C    'PATKA'    ,   'GOLED'    ,   'BUTLA'    ,   'ASAS'     ,
     C    'LOTRA'    ,   'AHPD'     ,   'DOGAR'    ,   'SAPAR'    ,
     C    'UPLOK'    ,   'EMPUL'    ,   'YYT'      ,   'LAGOD'    ,
     C    'OYSTR'    ,   'SABKI'    ,   'SADMI'    ,   'APGN'     ,
     C    'BOLAK'    ,   'OLDIS'    ,   'DOTTI'    ,   'ASMA'     ,
     C    'PBO'      ,   'CARPE'    ,   'OYSTER'   ,   'GULOR'    ,
     C    'JARRA'    ,   'GURNO'    ,   'OKTOM'    ,   'SEMKO'    ,
     C    'VILOK'    ,   'MAKVO'    ,   'MTP'      ,   'SULRA'    ,
     C    'BOTRA'    ,   'EKUSA'    ,   'DOGIS'    ,   'INSREP'   ,
     C    'TAMUS'    ,   'SELNI'    ,   'SEMKU'    ,   'FLO'      ,
     C    'COLOR'    ,   'SCROD'    ,   'YYR'      ,   'ULTEM'    ,
     C    'YQX'      ,   'CYYR'     ,   'ABTL'     ,   'ALBAR'    ,
     C    'BRAVO'    ,   'ABMA'     ,   'UNSOK'    ,   'HOGAN'    ,
     C    'ALGAE'    ,   'MALIM'    ,   'PASKA'    ,   'SBBG'     ,
     C    'UGURA'    ,   'SBFL'     ,   'DOTTY'    ,   'GOTSI'    /
C
      DATA (YLOCAT(I),I=121,140) /
     C    'ANOLA'    ,   'DUGES'    ,   'REDOK'    ,   'RPB'      ,
     C    'FIR'      ,   'YSG'      ,   'AY'       ,   'QX'       ,
     C    'VYSTA'    ,   'SG'       ,   'BANCS'    ,   'YAY'      ,
     C    'SBFZ'     ,   'SBPL'     ,   'KONSA'    ,   'AMMG'     ,
     C    'TOKSO'    ,   'OSCAR'    ,   'LIMA'     ,   'PAKSI'    /
C
      data (ylocat(i),i=141,195) /
     c    'BELEM'    ,   'CARAVELAS',   'RECIFE'   ,   'NORONHA'  ,
     C    'RAKUD'    ,   'PAKON'    ,   'MANAUS'   ,   'PALES'    ,
     C    'LETICIA'  ,   'ABUNA'    ,   'MARICA'   ,   'ABROLHOS' ,
     C    'AMROG'    ,   'AGVAD'    ,   'BUGAT'    ,   'KODOS'    ,
     C    'FOZ'      ,   'INDIO'    ,   'ACARI'    ,   'NELOS'    ,
     C    'BRASILIA' ,   'PRATA'    ,   'BAGE'     ,   'VAGAN'    ,
     C    'CUIABA'   ,   'ELANA'    ,   'IGAPO'    ,   'BRACO'    ,
     C    'OIAPOQUE' ,   'SOSKO'    ,   'LOPTA'    ,   'PORGI'    ,
     C    'GARUP'    ,   'VODSA'    ,   'TURAB'    ,   'MELEM'    ,
     C    'AKRAN'    ,   'POLVO'    ,   'DESEX'    ,   'EMTUP'    ,
     C    'BILUX'    ,   'ASKOD'    ,   'ATASA'    ,   'ALGAL'    ,
     C    'ILGER'    ,   'MOCORO'   ,   'REPUR'    ,   'ONTER'    ,
     C    'TIPTU'    ,   'LOMAK'    ,   'NANIK'    ,   'EVBOT'    ,
     C    'FORTALEZA',   'GERSO'    ,   'SANTAREM' /
c
C
      DATA (ILAT(I),I=1,60) /
     C    -3392      ,    -1400     ,    -3620     ,    -1767     ,
     C    -3838      ,    -2580     ,    -2083     ,    -3000     ,
     C    -2197      ,    -3423     ,    -3188     ,    -1800     ,
     C    -2487      ,    -2338     ,    -1200     ,    -2547     ,
     C    -3017      ,     2850     ,    -1937     ,    -2538     ,
     C    -1900      ,    -3740     ,    -3547     ,    -3255     ,
     C    -1227      ,    -3760     ,    -3192     ,    -3768     ,
     C    -4067      ,    -2803     ,     1237     ,    -1737     ,
     C      683      ,      800     ,     1100     ,      700     ,
     C    -1800      ,    -1200     ,    -4058     ,    -1200     ,
     C     -300      ,    -1400     ,    -1937     ,    -2367     ,
     C    -3285      ,    -3792     ,    -2888     ,    -3888     ,
     C    -3985      ,     -885     ,    -3800     ,    -2228     ,
     C     5080      ,     2621     ,     5707     ,     5555     ,
     C    -3315      ,     4734     ,     4857     ,    -4053     /
C
      DATA (ILAT(I),I=61,120) /
     C      800      ,    -3912     ,   -3257      ,    -2380     ,
     C    -3360      ,    -2038     ,    -200      ,    -3113     ,
     C    -1200      ,     -800     ,    4766      ,    -3000     ,
     C     5400      ,    -2903     ,   -2550      ,    -2877     ,
     C      600      ,     1190     ,       0      ,    -2073     ,
     C    -2317      ,     5320     ,    2621      ,    -3788     ,
     C    -2050      ,    -3432     ,   -3223      ,    -2508     ,
     C    -1400      ,    -2880     ,   -3413      ,    -4175     ,
     C    -2600      ,     1540     ,   -1400      ,    99999     ,
     C    -2000      ,    -3547     ,   -3442      ,    99999     ,
     C    99999      ,     5460     ,   99999      ,    99999     ,
     C    99999      ,    99999     ,   -1925      ,    -2038     ,
     C     4748      ,    99999     ,   99999      ,     1775     ,
     C    -2113      ,    99999     ,   99999      ,    99999     ,
     C    99999      ,    99999     ,   99999      ,    99999     /
C
      DATA (ILAT(I),I=121,140) /
     C    -2172      ,    99999     ,   99999      ,    99999     ,
     C    99999      ,    99999     ,    5215      ,    99999     ,
     C    99999      ,    99999     ,   99999      ,    99999     ,
     C    99999      ,    99999     ,   99999      ,    -3773     ,
     C    99999      ,     4117     ,   99999      ,    -3618     /
C
      data (ilat(i),i=141,195) /
     c   -00123      ,   -01738     ,  -00808      ,   -00352     ,
     c    00324      ,    00428     ,  -00302      ,   -01354     ,
     c   -00411      ,   -01100     ,  -02258      ,   -01758     ,
     c   -01313      ,   -00826     ,  -00337      ,    00112     ,
     c   -02534      ,   -02755     ,   00157      ,   -00751     ,
     c   -01552      ,   -01649     ,  -03123      ,    00349     ,
     c   -01539      ,   -00055     ,  -00536      ,    00144     ,
     c    00351      ,   -02630     ,  -02821      ,   -02925     ,
     c   -01838      ,   -01536     ,  -01226      ,   -00909     ,
     c   -00549      ,   -01813     ,  -01409      ,   -01000     ,
     c   -00549      ,   -00136     ,  -02133      ,   -01951     ,
     c   -01727      ,   -00511     ,   00001      ,    00514     ,
     c   -00601      ,   -01105     ,   00620      ,    00116     ,
     c   -00346      ,   -01108     ,  -00225      /
c
C
      DATA (ILONG(I),I=1,60) /
     C   16500       ,    15842     ,    16500     ,    14107     ,
     C   16000       ,    14988     ,    15583     ,    15832     ,
     C   13083       ,    14208     ,    15800     ,    11062     ,
     C   11365       ,    15047     ,    11833     ,    16300     ,
     C   14310       ,    13015     ,    16300     ,    13672     ,
     C   14925       ,    16000     ,    16000     ,    14960     ,
     C   13683       ,    14973     ,    16000     ,    16500     ,
     C   16000       ,    14562     ,    11090     ,    12365     ,
     C   10380       ,    10650     ,    10952     ,    10597     ,
     C   11098       ,    10888     ,    16500     ,    11143     ,
     C   13348       ,    14785     ,    16300     ,    12237     ,
     C   16300       ,    15500     ,    12900     ,    15500     ,
     C   16000       ,    13807     ,    16000     ,    15963     ,
     C     835       ,    12300     ,     5906     ,    -5650     ,
     C   14825       ,     -683     ,    -5474     ,    17000     /
C
      DATA (ILONG(I),I=61,120) /
     C   10650       ,   16500      ,   16000      ,    13388     ,
     C   15415       ,   11862      ,    8785      ,    15800     ,
     C   12137       ,     9308     ,   -5250      ,    17925     ,
     C   -5500       ,    16300     ,   16800      ,    11465     ,
     C    9550       ,    8253      ,   15607      ,    13952     ,
     C   11773       ,    -5400     ,   12300      ,    16500     ,
     C   13332       ,   15415      ,   16000      ,    15410     ,
     C   14223       ,   15500      ,   13533      ,    16500     ,
     C   10892       ,   11400      ,    9830      ,    99999     ,
     C   10333       ,   13000      ,   12500      ,    99999     ,
     C   99999       ,    -5580     ,   99999      ,    99999     ,
     C   99999       ,   99999      ,   14675      ,    15300     ,
     C     608       ,   99999      ,   99999      ,    13283     ,
     C   15800       ,   99999      ,   99999      ,    99999     ,
     C   99999       ,   99999      ,   99999      ,    99999     /
C
      DATA (ILONG(I),I=121,140) /
     C   16300       ,   99999      ,   99999      ,    99999     ,
     C   99999       ,   99999      ,    2100      ,    99999     ,
     C   99999       ,   99999      ,   99999      ,    99999     ,
     C   99999       ,   99999      ,   99999      ,    14078     ,
     C   99999       ,     501      ,   99999      ,    17185     /
C
      data(ilong(i),i=141,195) /
     c   -04828      ,   -03915     ,  -03455      ,   -03227     ,
     c   -02911      ,   -06118     ,  -06007      ,   -05829     ,
     c   -06956      ,   -06711     ,  -04253      ,   -03842     ,
     c   -03526      ,   -03218     ,  -02914      ,   -02613     ,
     c   -05430      ,   -05013     ,  -05629      ,   -05208     ,
     c   -04801      ,   -04003     ,  -05406      ,   -06305     ,
     c   -05606      ,   -06739     ,  -06149      ,   -06904     ,
     c   -05148      ,   -03000     ,  -02000      ,   -01000     ,
     c   -03716      ,   -03156     ,  -02645      ,   -02141     ,
     c   -01644      ,   -03808     ,  -03403      ,   -03005     ,
     c   -02613      ,   -02226     ,  -03000      ,   -02000     ,
     c   -01000      ,   -03721     ,  -03430      ,   -03139     ,
     c   -06535      ,   -06721     ,  -03310      ,   -03552     ,
     c   -03832      ,   -06733     ,  -05449      /
c
C     ------------------------------------------------------------------
C*          1. CLEAR FLAGS AND ERROR INDICATOR . RETAIN POINTER TO FIRST
C              ---------------------------------------------------------
C              CHARACTER OF REPORT.
C              --------------------
  100 CONTINUE
C
C     FLAG INDICATING FIRST DECODING ATTEMPT ON REPORT.
C
      IFIRST = 0
      ISLESH = 0
C
C     POINTER TO FIRST CHARACTER
C
      KPT = IPT
C
C     ERROR INDICATOR
C
  101 KERR = 0
C
C
C
C*                1.1  CHECK FOR 'NIL' REPORT.
C                      -----------------------
 110  CONTINUE
C
      LEN = IEQ -IPT
      IF (LEN.LE.25) THEN
                         KERR = 1
                         NOER(2,1) = NOER(2,1) + 1
C
C-----                   PRINT 'NIL' AIRCRAFT REPORTS
C-----
C-----                   CALL PRTBULL (IPT,IEQ)
C-----
C-----                   PRINT 'NIL' AIRCRAFT REPORTS
C
                         KDEC(20)=1
C
                         RETURN
                     END IF
C
C
C*               1.2 SET AREA FOR INTERMEDIATE FORM OF REPORT
C                    ----------------------------------------
C                    TO MISSING DATA VALUE.
C                    ----------------------
 120  CONTINUE
C
      DO 121 I=6,25
         KINT(I) = MINDIC
  121 CONTINUE
C
C
C     WORDS 1-65 ARE SET TO CCITT 5 'XXX  ' .AIRCRAFT CALL SIGN ( IF
C     IT EXISTS ) OVERWRITES THESE WORDS.
C
      DO 122 I=1,3
         IDENT(I) = 88
  122 CONTINUE
C
      IDENT(4) = 32
      IDENT(5) = 32
      IDENT(6) = 32
      IDENT(7) = 32
      IDENT(8) = 32
      IDENT(9) = 32
C
C
C     PRESET MINUTES OF LATITUDE AND LONGITUDE TO 0.
C
      KINT(7)  = 0
      KINT(10) = 0
C
C     PRESET AUTOMATIC REPORT INDICATOR TO 0 .
C
      KINT(24) = 0
C
C
C
C*               1.3 CLEAR DATA FOR PREVIOUS REPORT FROM
C                    -----------------------------------
C                    DECODED REPORT HEADER AREA.
C                    ---------------------------
 130  CONTINUE
C
      DO 131 I=1,3
         KDEC(I) = MINDIC
  131 CONTINUE
C
      DO 132 I=5,9
         KDEC(I) = MINDIC
  132 CONTINUE
C
C     CLEAR FLAG FIELDS , RETAINING 'COR' FLAG.
C
      KDEC(13) = 0
      KDEC(15) = KDEC(15).AND.4
      KDEC(16) = MINDIC
      KDEC(17) = MINDIC
      KDEC(20) = 0
C
      DO 133 I=22,24
         KDEC(I) = MINDIC
  133 CONTINUE
C
C
C*                   1.4 TEST FOR CALL SIGN - FIRST CHARACTER NON-NUMERIC.
C                        -------------------------------------------------
 140  CONTINUE
C
      IF ( KCHAR(IPT).LT.48.OR.KCHAR(IPT).GT.57)
     C    THEN
C
C             INSERT FIRST 5 CHARACTERS OF CALL SIGN IN WORDS 1-5.
C
C             ANY 'SPACE' IS IGNORED IF NO FIGURE IS ENCOUNTERED .
C             CALL SIGN NORMALLY CONSISTS OF 2 LETTERS AND FIGURES ,
C             BUT SOME CENTRES LEAVE A 'SPACE' BETWEEN LETTERS AND
C             FIGURES.
C             E.G.  AF13 , AF 13 .
C
              J = 1
              IFIG = 0
              DO 141 K=1,8
                     IF (KCHAR(IPT).GE.48.AND.KCHAR(IPT).LE.57)IFIG=1
                     IF (IFIG.EQ.0.AND.KCHAR(IPT).EQ.32) GO TO 142
                     if (ifig.eq.0.and.kchar(ipt).eq.13) then
c
c                        skip this group of characters
c
                        call nextprt(ipt,ieq)
                        go to 140
                     end if
c
                     IF (KCHAR(IPT).EQ.32) GO TO 145
                     if (kchar(ipt).eq.13) go to 145
                     if (kchar(ipt).eq.10) go to 145
                     IDENT(J) = KCHAR(IPT)
                     J = J + 1
  142                IPT = IPT + 1
  141         CONTINUE
C
C             CHECK FOR AUTOMATIC REPORT ( LETTER 6 OF CALL SIGN A Z )
C
              KINT(24) = 0
              IF ( KCHAR(IPT).EQ.90 ) KINT(24) = 1
C
C             LOCATE LAT/LONG GROUP . SOME REPORTS DO NOT HAVE
C             ABBREVIATED CALL SIGNS , SO IF NO FIGURE HAS BEEN
C             ENCOUNTERED THE LAT/LONG GROUP IS THE FIRST GROUP
C             AFTER THE NEXT FIGURE .
C             E.G.  ASCOTT 123 , KIWI 123 .
C
              IF ( IFIG.EQ.0 ) CALL NEXTFIG (IPT,IEQ)
              CALL NEXTVAL (IPT,32,IEQ)
C
  145         CONTINUE
C
              CALL NEXTPRT (IPT,IEQ)
C
          ELSE
C
C             MISSING CALL SIGN .
C
              IF (IFIRST.EQ.0) NOER(2,2) = NOER(2,2) + 1
C
C
          END IF
C
C
C*                1.5   CONVERT LAT/LONG GROUP.
C                       -----------------------
C
 150  CONTINUE
C
C     IF THE CHARACTER ENCOUNTERED IS A LETTER , LAT/LONG IS
C     GIVEN BY A PLACE NAME AND LAT/LONG MUST BE TAKEN FROM THE
C     TABLES OF LAT/LONG/LOCATION INDICATORS.
C
C     FIRST CHECK IF LATITUDE ONLY IS GIVEN BY 'EQ' , DENOTING
C     EQUATOR.
C
      ISEQU = 0
      IF (KCHAR(IPT).GE.65.AND.KCHAR(IPT+1).LE.90) ISEQU = 1
C
      IF (KCHAR(IPT).EQ.69.AND.KCHAR(IPT+1).EQ.81.AND.
     C    KCHAR(IPT+2).EQ.32)
     C          THEN
                    KINT(6) = 0
                    KINT(8) = 0
                    ISEQU = 2
                    IPT = IPT + 2
                ENDIF
C
      IF ( ISEQU.EQ.1 )
     C    THEN
C
C             SET ARRAY FOR LOCATION CHARACTERS TO 'SPACES'.
C
              DO 151 I=1,10
                     ILOC(I) = 32
  151         CONTINUE
C
C             CHECK LOCATION INDICATOR.
C
              I1 = IPT
              I2 = IPT
              CALL NEXTVAL (I2,32,IEQ)
              I2 = I2 - 1
              IF((I2-I1).GE.10) THEN
                 KERR=4
                 GO TO 9000
              END IF
C
              K = 0
C
              DO 152  I=I1,I2
                      K = K + 1
                      ILOC(K) = KCHAR(I)
                      IF ( ILOC(K).EQ.32 ) GO TO 153
 152          CONTINUE
C
 153          CONTINUE
C
              YLOC=' '
              DO 154 I=1,10
              YLOC(I:I)=CHAR(ILOC(I))
 154          CONTINUE

C
              DO 155  I=1,NDEF
                     IF (YLOC.EQ.YLOCAT(I)) GO TO 156
 155          CONTINUE
C
C             LOCATION INDICATOR NOT IN TABLE.
C
              CALL NEXTVAL (IPT,32,IEQ)
              KCHAR(IPT) = KCHAR(IPT).OR.128
              KERR = 4
              IF (IFIRST.EQ.0) NOER(2,4) = NOER(2,4) + 1
              GO TO 9000
C
C
C             INSERT LATITUDE .
C
C             RETURN IF LOCATION IDENTIFIER IS RECOGNISED BUT
C             COORDINATES NOT KNOWN.
C
 156          IF (ILAT(I).EQ.99999 )
     C                 THEN
                           NOER(2,4) = NOER(2,4) + 1
                           KERR = 4
                           RETURN
                       ENDIF
C
              KINT(6) =ILAT(I)
              KINT(8) = 0
C
C             INSERT LONGITUDE .
C
              KINT(9) =ILONG(I)
              KINT(11) = 0
C
C             MOVE WORKING POINTER PAST LOCATION INDICATOR GROUP.
C
              CALL NEXTVAL (IPT,32,IEQ)
C
C
          ELSE
C
C
C             CHECK IF LATITUDE ALREADY GIVEN BY 'EQ'.
C
              IF ( ISEQU.EQ.2 ) GO TO 157
C
C             SOME CENTRES USE 3 FIGURES FOR DEGREES OF LATITUDE.
C             THE EXTRA FIGURE IS A LEADING  0 .
C
C             CHECK FOR LEADING 0 WHEN LATITUDE IS GIVEN IN
C             WHOLE DEGREES.
C
              IF ( KCHAR(IPT).EQ.48.AND.KCHAR(IPT+1).GE.48.AND.
     C             KCHAR(IPT+1).LE.57.AND.KCHAR(IPT+2).GE.48.AND.
     C             KCHAR(IPT+2).LE.57.AND.KCHAR(IPT+3).GE.65)
     C               IPT = IPT + 1
C
C              CHECK FOR LEADING 0 WHEN LATITUDE IS IN DEGREES
C              AND MINUTES .
C
              IF ( KCHAR(IPT).EQ.48.AND.KCHAR(IPT+1).GE.48.AND.
     C             KCHAR(IPT+1).LE.57.AND.KCHAR(IPT+2).GE.48.AND.
     C             KCHAR(IPT+2).LE.57.AND.KCHAR(IPT+3).GE.48.AND.
     C             KCHAR(IPT+3).LE.57.AND.KCHAR(IPT+4).GE.48.AND.
     C             KCHAR(IPT+4).LE.57.AND.KCHAR(IPT+5).GE.65)
     C               IPT = IPT + 1
C
C              CONVERT DEGREES OF LATITUDE.
C
               CALL EXTINT(IPT,2,6)
               IF ( KINT(6).EQ.MINDIC)
     C              THEN
                        IF ( IFIRST.EQ.0 ) NOER(2,4) = NOER(2,4) + 1
                        KERR = 4
                        IPT=IABS(IPT)
                        KCHAR(IPT) = KCHAR(IPT).OR.128
                        GO TO 9000
                    END IF
C
C
C             TEST FOR MINUTES OF LATITUDE ( NEXT CHARACTER NOT 'N'
C             OR 'S' OR 'SPACE' .
C
              IF (KCHAR(IPT).NE.78.AND.KCHAR(IPT).NE.83.AND.
     C            KCHAR(IPT).NE.32)
     C             THEN
                       CALL EXTINT (IPT,2,7)
                       IF ( KINT(7).EQ.MINDIC)
     C                   THEN
                           IF ( IFIRST.EQ.0 ) NOER(2,4)=NOER(2,4)+1
                           KERR = 4
                           IPT=IABS(IPT)
                           KCHAR(IPT) = KCHAR(IPT).OR.128
                           GO TO 9000
                         END IF
                   END IF
C
C
C             'N' (+) OR 'S' (-) .
C
              IF (KCHAR(IPT).EQ.78) KINT(8) = 1
              IF (KCHAR(IPT).EQ.83) KINT(8) = -1
C
C             CHECK FOR LATITUDE OF 00 WITH MISSING 'N' OR 'S'.
C
              IF (KINT(8).EQ.MINDIC.AND.KINT(6).EQ.0) KINT(8)=1
C
              IF (KINT(8).EQ.MINDIC)
     C                   THEN
                           IF ( IFIRST.EQ.0 ) NOER(2,4)=NOER(2,4)+1
                           KERR = 4
                           IPT=IABS(IPT)
                           KCHAR(IPT) = KCHAR(IPT).OR.128
                           GO TO 9000
                         ELSE
                             IPT=IPT+1
                         END IF
C
C
C             CONVERT DEGREES OF LONGITUDE . SOME CENTRES USE ONLY
C             2 DIGITS WHEN LONGITUDE IS LESS THAN 100 .
C
 157          CALL NEXTPRT ( IPT,IEQ )
              N = 3
              if(kchar(ipt+2).eq.69.or.kchar(ipt+2).eq.87.or. 
     1           kchar(ipt+4).eq.69.or.kchar(ipt+4).eq.87) n=2
c
c             IF (KCHAR(IPT+3).EQ.32.OR.KCHAR(IPT+5).EQ.32) N=2
              CALL EXTINT (IPT,N,9)
              IF ( KINT(9).EQ.MINDIC )
     C                   THEN
                           IF ( IFIRST.EQ.0 ) NOER(2,4)=NOER(2,4)+1
                           KERR = 4
                           IPT=IABS(IPT)
                           KCHAR(IPT) = KCHAR(IPT).OR.128
                           GO TO 9000
                         END IF
C
C             TEST FOR MINUTES OF LONGITUDE ( NEXT CHARACTER NOT
C             'E' OR 'W' OR 'SPACE' . FIRST CORRECT IF INCORRECT
C             FIGURE-SHIFT.
C
              IF (KCHAR(IPT).EQ.51.AND.KCHAR(IPT+1).EQ.32)
     C                KCHAR(IPT) = 69
              IF (KCHAR(IPT).EQ.50.AND.KCHAR(IPT+1).EQ.32)
     C                KCHAR(IPT) = 87
C
              IF ( KCHAR(IPT).NE.69.AND.KCHAR(IPT).NE.87 )
     C             THEN
                       CALL EXTINT (IPT,2,10)
                       IF ( KINT(10).EQ.MINDIC )
     C                     THEN
                               IF (IFIRST.EQ.0) NOER(2,4)=NOER(2,4)+1
                               KERR = 4
                               IPT=IABS(IPT)
                               KCHAR(IPT) = KCHAR(IPT).OR.128
                               GO TO 9000
                           END IF
C
                   END IF
C
C
C             'E' (+) OR 'W' (=).
C
              IF (KCHAR(IPT).EQ.69) KINT(11) = 1
              IF (KCHAR(IPT).EQ.87) KINT(11) = -1
C
C             CHECK FOR LONGITUDE OF 180 WITH MISSING 'E' OR 'W'.
C
              IF (KINT(11).EQ.MINDIC.AND.KINT(9).EQ.180)KINT(11)=1
C
              IF (KINT(11).EQ.MINDIC)
     C             THEN
                               KERR = 4
                               IPT=IABS(IPT)
                               KCHAR(IPT) = KCHAR(IPT).OR.128
                               GO TO 9000
                           ELSE
                               IPT=IPT+1
                           END IF
          END IF
C
C
C*           1.6 LOCATE AND CONVERT TIME GROUP . THIS IS NORMALLY HHMM BUT
C                SOME REPORTS GIVE ONLY THE MINUTES (MM) . IN THIS CASE
C                THE HOURS VALUE (HH) IS TAKEN FROM THE BULLETIN HEADER ( -1
C                IF MINUTES IN REPORT IS GREATER THAN MINUTES IN HEADER ).
C                OCCASIONALLY THE DAY IS ALSO INCLUDED , AND IN THIS CASE
C                THE POINTER IS MOVED PAST THE DAY TO THE HH FIGURES.
C                TIME GROUP IS FOLLOWED BY '/' OR 'SPACE'.
C
C
      CALL NEXTPRT ( IPT,IEQ )
C
      K = IPT
      CALL NEXTVAL ( K,32,IEQ )
      K = K - IPT
      J = IPT
      CALL NEXTVAL ( J,47,IEQ )
      J = J -IPT
      IF ( K.GT.J ) K = J
      IF ( K.EQ.6 ) IPT = IPT + 2
C
      IF ( KCHAR(IPT+2).EQ.47.OR.KCHAR(IPT+2).EQ.32 )
     C      THEN
                KINT(12) = KDEC(11)
                CALL EXTGRP ( IPT,2,0,0,0,0,13,IRET)
                IF ( KINT(13).GT.KDEC(12) ) KINT(12) = KINT(12) - 1
                IF ( KINT(12).EQ.-1 ) KINT(12)=23
            ELSE
                CALL EXTGRP ( IPT,2,2,0,0,0,12,IRET )
            ENDIF
C
C
      IF (KINT(12).LT.0.OR.KINT(12).GT.23) IRET = 1
      IF (KINT(13).LT.0.OR.KINT(13).GT.59) IRET = 1
      IF (IRET.NE.0)
     C    THEN
              IPT=IABS(IPT)
              KCHAR(IPT) = KCHAR(IPT).OR.128
              KERR = 3
              IF (IFIRST.EQ.0) NOER(2,3) = NOER(2,3) + 1
              GO TO 9000
          END IF
C
C*           1.7 CONVERT FLIGHT LEVEL . THIS IS GIVEN IN 3 FIGURES
C                IN THE NEXT GROUP AND IS NORMALLY PRECEDED BY
C                THE LETTER 'F' . A NUMBER OF VARIATIONS ARE
C                F330 , F 330 , FL330 , FL 330 , /330 , 330 , F/L 330 .
C                TO ACCOMMODATE THESE VARIATIONS THE NEXT FIGURE IS LOCATED.
C
 170  CONTINUE
C
      CALL NEXTFIG ( IPT,IEQ )
C
      CALL EXTINT (IPT,3,15)
      IF ( KINT(15).EQ.MINDIC )
     C              THEN
                      IPT = IABS(IPT)
                      KCHAR(IPT)=KCHAR(IPT).OR.128
                      KERR = 4
                      IF (IFIRST.EQ.0) NOER(2,4)=NOER(2,4)+1
                      GO TO 9000
                    END IF
C
C
C
C
C*                  1.8  LOCATE AND CONVERT TEMPERATURE GROUP
C                        ( 'S' PRECEDED BY 'P' OR
C
 180  CONTINUE
C
 185  CALL NEXTPRT (IPT,IEQ)
      IF (IPT.GE.IEQ)
     C   THEN
             KCHAR(IEQ) = KCHAR(IEQ).OR.128
             KERR = 5
             IF (IFIRST.EQ.0) NOER(2,5)=NOER(2,5)+1
             GO TO 9000
         END IF
C
C     CHECK FOR 'PS' OR 'MS' OR 'P' OR 'M'.
C
      IF ((KCHAR(IPT).EQ.80.OR.KCHAR(IPT).EQ.77).AND.KCHAR(IPT+1).
     C    GE.48.AND.KCHAR(IPT+1).LE.57) THEN
          INCR=1
          GO TO 181
      END IF
      IF ((KCHAR(IPT).EQ.80.OR.KCHAR(IPT).EQ.77).AND.KCHAR(IPT+1).
     C    EQ.83) THEN
          INCR=2
          GO TO 181
      END IF
C
C     CHECK IF GROUP IS A WIND GROUP . ANY OTHER GROUPS ARE SKIPPED.
C
C
      IF (KCHAR(IPT).GE.48.AND.KCHAR(IPT).LE.57)
     C       THEN
C
C                IF GROUP STARTS WITH A FIGURE AND 4TH CHARACTER IS /
C                IT IS A WIND GROUP.
C
                 ISLESH=0
                 IF (KCHAR(IPT+3).EQ.47) GO TO 182
                 III=IPT
                 CALL NEXTSEP(III,IEQ)
                 IIIIPT=III-IPT
                 IF(IIIIPT.GE.4.AND.IIIIPT.LE.6) THEN
                    ISLESH=1
                    GO TO 182
                 END IF 
C
             ELSE
C
C                IF GROUP IS 'LV' OR 'L/V' IT IS A WIND GROUP.
C
                 IF (KCHAR(IPT).EQ.76.AND.KCHAR(IPT+1).EQ.47)GO TO 182
                 IF (KCHAR(IPT).EQ.76.AND.KCHAR(IPT+1).EQ.86)GO TO 182
C
C                IF GROUP IS 'CALM' IT IS A WIND GROUP.
C
                 IF (KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.65.AND.
     C            KCHAR(IPT+2).EQ.76.AND.KCHAR(IPT+3).EQ.77) GO TO 182
C
C                IF GROUP IS 'VRB' IT IS A WIND GROUP.
C
                 IF (KCHAR(IPT).EQ.86.AND.KCHAR(IPT+1).EQ.82.AND.
     C            KCHAR(IPT+2).EQ.66) GO TO 182
C
             ENDIF
C
C     SKIP GROUP.
C
      CALL NEXTVAL (IPT,32,IEQ)
      GO TO 185
C
C
C     'P' ( + )   OR 'M'  ( - )
C
 181  IF (KCHAR(IPT).EQ.80 ) KINT(18) = 1
      IF (KCHAR(IPT).EQ.77 ) KINT(18) = -1
C
C     TEMPERATURE
C
      IPT=IPT+INCR
      CALL NEXTPRT ( IPT,IEQ )
      CALL EXTINT (IPT,2,19)
C
 183  IF (IPT.LT.0)
     C    THEN
              IPT = IABS(IPT)
              KCHAR(IPT) = KCHAR(IPT).OR.128
              KERR = 5
              IF (IFIRST.EQ.0) NOER(2,5)=NOER(2,5)+1
          END IF
C
C
C
C*               1.9  LOCATE AND CONVERT WIND GROUP.
C                     ------------------------------
 190  CONTINUE
C
      CALL NEXTSEP (IPT,IEQ)
      CALL NEXTPRT (IPT,IEQ)
      IF (IPT.GE.IEQ) GO TO 9000
C
C
C     CHECK IF GROUP IS   L/V  . CONVERTED AS 990/02  .
C
      IF (KCHAR(IPT).EQ.76)
     C    THEN
              KINT(20) = 990
              KINT(21) = 2
              GO TO 9000
          END IF
C
C
C     CHECK IF GROUP IS 'CALM' . CONVERTED AS 000/00 .
C
      IF (KCHAR(IPT).EQ.67)
     C    THEN
              KINT(20) = 0
              KINT(21) = 0
              GO TO 9000
          END IF
C
C     CHECK IF DDD IS GIVEN AS 'VRB'.
C
      IF (KCHAR(IPT).EQ.86)
     C   THEN
            KINT(20) = 990
            CALL NEXTFIG (IPT,IEQ)
            GO TO 191
         END IF
C
      IF (KCHAR(IPT).GE.48.AND.KCHAR(IPT).LE.57) THEN
C
C       IF GROUP STARTS WITH A FIGURE AND 4TH CHARACTER IS /
C       IT IS A WIND GROUP.
C
        ISLESH=0
        IF (KCHAR(IPT+3).EQ.47) GO TO 182
        III=IPT
        CALL NEXTSEP(III,IEQ)
        IIIIPT=III-IPT
        IF(IIIIPT.GE.4.AND.IIIIPT.LE.6) THEN
           ISLESH=1
           GO TO 182
        ELSE
C
C          SKIP THAT GROUP
C
           IPT=III
           GO TO 190
C
        END IF 
C
      ELSE
C
C         IF GROUP IS 'LV' OR 'L/V' IT IS A WIND GROUP.
C
          IF (KCHAR(IPT).EQ.76.AND.KCHAR(IPT+1).EQ.47)GO TO 182
          IF (KCHAR(IPT).EQ.76.AND.KCHAR(IPT+1).EQ.86)GO TO 182
C
C         IF GROUP IS 'CALM' IT IS A WIND GROUP.
C
          IF (KCHAR(IPT).EQ.67.AND.KCHAR(IPT+1).EQ.65.AND.
     C    KCHAR(IPT+2).EQ.76.AND.KCHAR(IPT+3).EQ.77) GO TO 182
C
C         IF GROUP IS 'VRB' IT IS A WIND GROUP.
C
          IF (KCHAR(IPT).EQ.86.AND.KCHAR(IPT+1).EQ.82.AND.
     C    KCHAR(IPT+2).EQ.66) GO TO 182
C
C         WIND GROUP GAN BE /////// MISSING
C
          IF (KCHAR(IPT).EQ.47.AND.KCHAR(IPT+1).EQ.47.AND.
     C    KCHAR(IPT+2).EQ.47.AND.KCHAR(IPT+3).EQ.47) GO TO 9000
      ENDIF
C
C     CONVERT DDD TO INTEGER. FIND THE POSITION OF THE NEXT
C     FIGURE , AS SOMETIMES THE WORD 'SPOT' OR 'SPT' OR 'S'
C     PRECEDES THE WIND GROUP.
C
 182  CALL NEXTFIG (IPT,IEQ)
      IF (IPT.GE.IEQ) GO TO 9000
      CALL EXTINT(IPT,3,20)
      IF ( KINT(20).EQ.MINDIC)
     C    THEN
             IPT=IABS(IPT)
             KCHAR(IPT)=KCHAR(IPT).OR.128
             KERR = 6
             IF (IFIRST.EQ.0) NOER(2,6)=NOER(2,6)+1
          END IF
C
C     FFF CAN BE 1,2 OR 3 FIGURES , SO CONVERTED SEPARATELY.
C     SOME CENTRES LEAVE A 'SPACE' BETWEEN / AND FFF .
C
 191  IF(ISLESH.NE.1) IPT = IPT+1
      CALL NEXTFIG (IPT,IEQ)
      CALL EXTINT (IPT,1,21)
      IF ( KINT(21).EQ.MINDIC)
     C    THEN
             IPT=IABS(IPT)
             KCHAR(IPT)=KCHAR(IPT).OR.128
             KERR = 6
             IF (IFIRST.EQ.0) NOER(2,6)=NOER(2,6)+1
          END IF
C
      CALL EXTINT (IPT,1,22)
      CALL EXTINT (IPT,1,23)
C
C
C
C     RETURN IF NO ERROR ENCOUNTERED.
C
C
C
 9000 IF (KERR.EQ.0) RETURN
C
C     IF FIRST DECODING ATTEMPT , TRY TO CORRECT ERRORS AND
C     DECODE AGAIN.
C
      IF (IFIRST.EQ.0)
     C    THEN
              IPT = KPT
              CALL FIXUA
              IFIRST = 1
              GO TO 101
          ELSE
              CALL SAVREP(IHEAD,IERR)
C
C             CLEAR ERROR INDICATOR ,IF THE ERROR IS NOT IN
C             LOCATION OR TIME .
C
c               IF ( KERR.GT.4 ) KERR = 0
              if(kerr.gt.4) then
                kerr = 0
c               ierr = 0
              end if
          END IF
C
C
      RETURN
      END
      SUBROUTINE FIXUA
C
C**** *FIXUA*
C
C
C     PURPOSE.
C     --------
C         ERROR FIXING ROUTINE FOR AIREP REPORTS.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *FIXUA*
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
C
C     ------------------------------------------------------------------
C
C*          1.   CLEAR PARRITY BIT.                .
C                ------------------
 100  CONTINUE
C
C
      DO 101 I=KPT,IEQ
         KCHAR(I) = KCHAR(I).AND.127
  101 CONTINUE
C
C
C     KWBC INSERT //// IF NO TEMPERATURE IS REPORTED.
C     GROUP REPLACED BY MS// .
C
      DO 102 I=KPT,IEQ
         IF (KCHAR(I).EQ.47.AND.KCHAR(I+1).EQ.47.AND.KCHAR(I+2)
     C      .EQ.47.AND.KCHAR(I+3).EQ.47 )
     C            THEN
                      KCHAR(I) = 77
                      KCHAR(I+1) = 83
                  END IF
  102 CONTINUE

      RETURN
      END
      
      SUBROUTINE UADEC ( IHEAD,IERR )
C
C**** *UADEC*
C
C
C     PURPOSE.
C     --------
C         CONVERSION FROM INTEGER REPRESENTATION TO FULLY DECODED
C         FORMAT.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *UADEC(IHEAD,IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *EXBAIR (IERR)*
C         *CALL* *KTOMPSI(I)*
C         *CALL* *QCAIREP(IERR)*
C         *CALL* *BUFRENC(IERR)*          
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      include 'comwt.h'
C
      DIMENSION IDM(12)
      DATA IDM/31,28,31,30,31,30,31,31,30,31,30,31/
C     ------------------------------------------------------------------
C*          1.   DECODE INTO DECODED FORMAT.       .
C                ---------------------------
 100  CONTINUE
C
c     call prtkint(kint,1,30,mindic)
C
C     CLEAR ERROR INDICATOR
C
      KERR = 0
C
C     SET DECODED REPORT AREA TO MISSING DATA VALUE.
C
      DO 101 I=25,32
         KDEC(I) = MINDIC
  101 CONTINUE
C
C     ------------------------------------------------------------------
C*          1.2  Y'Y' IS NOT REPORTED.
C                ---------------------
 120  CONTINUE
C
C     ------------------------------------------------------------------
C*          1.3  G'G'. HOUR FROM REPORT
C                -----
 130  CONTINUE
C
      KDEC(2) = KINT(12)
      KDEC(1) = KDEC(10) 
      IF(KINT(12).GT.KDEC(11)) THEN
         KDEC(1)=KDEC(1)-1
         IF(KDEC(1).EQ.0) THEN
            CALL DATUM(KDEC(10),IMONTH,IYEAR)
            IF(IMONTH.EQ.1) THEN
               KDEC(1)=31
            END IF
            IF(IMONTH.EQ.3) THEN
               KDEC(1)=28
               IF(MOD(IYEAR,4).EQ.0) KDEC(1)=29
            END IF
            IF(IMONTH.EQ.1) THEN
               KDEC(1)=IDM(12)
            ELSE
               KDEC(1)=IDM(IMONTH-1)     
            END IF
         END IF
      END IF 
C
C     ------------------------------------------------------------------
C*          1.4  LATITUDE.
C                ---------
 140  CONTINUE
C
      IF (KINT(8).EQ.0)
     C    THEN
              KDEC(5) = KINT(6)
          ELSE
              KDEC(5) = (KINT(6)*100 +(100*KINT(7))/60) * KINT(8)
          END IF
      IF(KDEC(5).LT.-9000.OR.KDEC(5).GT.9000) THEN
         KERR=4
         PRINT*,' UADEC : ERROR IN LATITUDE.'
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C*          1.5  LONGITUDE.
C                ----------
 150  CONTINUE
C
      IF (KINT(11).EQ.0)
     C    THEN
              KDEC(6) = KINT(9)
          ELSE
              KDEC(6) = (KINT(9)*100 +(100*KINT(10))/60) * KINT(11)
          END IF
      IF(KDEC(6).LT.-18000.OR.KDEC(6).GT.18000) THEN
         KERR=4
         PRINT*,' UADEC : ERROR IN LONGITUDE.'
         RETURN
      END IF
C
C     ------------------------------------------------------------------
C*          1.6  AIRCRAFT CALL SIGN.
C                -------------------
 160  CONTINUE
C
C
C     FIVE CHARATERS IN KINT(1) - KINT(5)  IN CCITT 5 .
C
C
C     ------------------------------------------------------------------
C*          1.7  ALTITUDE.
C                ---------
 170  CONTINUE
C
      KDEC(8) = INT( KINT(15) * 30.48 + 0.5 )
C
C     ------------------------------------------------------------------
C*          1.8  LITTLE G'G'.
C                ------------
 180  CONTINUE
C
      KDEC(9) = KINT(13)
C
C     ------------------------------------------------------------------
C*          1.9  PPP.
C                ----
 190  CONTINUE
C
      Z = KDEC(8)
      Z = P(Z) * 10.0
C
      KDEC(25) = INT ( Z + 0.5 )
C
C     ------------------------------------------------------------------
C*          2.   TT.
C                ---
 200  CONTINUE
C
      IF (KINT(19).NE.MINDIC.AND.KINT(18).NE.MINDIC)
     C    THEN
              KDEC(26) = KINT(19)*10*KINT(18)
          END IF
C
C
C     ------------------------------------------------------------------
C*          2.1  DD.
C                ---
 210  CONTINUE
C
      KDEC(27) = KINT(20)
      IF ( KDEC(27).EQ.990 ) KDEC(27) = 0
C
C     ------------------------------------------------------------------
C*          2.2  FFF.
C                ----
 220  CONTINUE
C
      KDEC(28) = KINT(21)
      IF (KDEC(28).NE.MINDIC.AND.KINT(22).NE.MINDIC)
     C    KDEC(28) = KDEC(28)*10 + KINT(22)
      IF (KDEC(28).NE.MINDIC.AND.KINT(23).NE.MINDIC)
     C    KDEC(28) = KDEC(28)*10 + KINT(23)
C
      IF (KDEC(28).NE.MINDIC) CALL KTOMPSI (KDEC(28))
C
C     SOME REPORTS USE 00000 INSTEAD ///// FOR WIND GROUP
C     SO RELPACE 0 DD AND 0 FFF WITH MINDIC
C
      IF(KDEC(27).EQ.0.AND.KDEC(28).EQ.0) THEN
         KDEC(27)=MINDIC
         KDEC(28)=MINDIC
      END IF
C
C     ------------------------------------------------------------------
C*          3.  WRITE REPORT TO FILE . FILE IS NUMBER 5 AND REPORT
C               LENGTH IS 32 WORDS .
C
 300  CONTINUE
C
      KDEC(24) = 32
C

      CALL EXBAIR(IERR)
      if(ierr.ne.0) then
         print*,'exbair:ierr=',ierr
         return
      end if
C
C     ------------------------------------------------------------------
C*          4.   QUALITY CONTROL TOVS DATA IN BUFR FORM.
C                ---------------------------------------
 400  CONTINUE
C
      CALL QCAIREP( IERR )
      if(ierr.ne.0) then
         print*,'qcairep:ierr=',ierr
         return
      end if
C
C
C     ------------------------------------------------------------------
C*          5.   ENCODE DATA IN BUFR MESSAGE AND PUT IN THE RDB.
C                -----------------------------------------------
 500  CONTINUE
C
      CALL BUFRENC( IERR )
      if(ierr.ne.0) then
         print*,'bufrenc:ierr=',ierr
         return
      end if
C
      RETURN
C
      END
      
      SUBROUTINE NEXTEQ ( I,J )
C
C**** *NEXTEQ*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT '=' CHARACTER.
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEQ(I,J)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCANE BULLETIN FOR NEXT '=' SIGN.
C                ---------------------------------
 100  CONTINUE
C
C     '=' IS 61 .
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 61) RETURN
  101 CONTINUE
C
      I=J
      RETURN
      END
      
      SUBROUTINE EXTINT ( I,N,K )
C
C**** *EXTINT*
C
C
C     PURPOSE.
C     --------
C         EXTRACTS N FIGURES FROM ARRAY 'KCHAR' , STARTING AT
C         WORD I , CONVERTS CHARACTERS TO INTEGER AND PLACES
C         IN WORD K OF 'KINT' .
C
C         INPUT     : I - POINTS TO FIRST CHARACTER TO BE EXTRACTED.
C                     N - NUMBER OF CCITT NO. 5 CHARACTERS TO BE EXTRACTED.
C
C         OUTPUT    : I - POINTS TO CHARACTER AFTER THE LAST ONE EXTRACTED.
C                         MADE NEGATIVE IF A 'SEPARATOR' IS FOUND IN THE
C                         CHARACTERS BEING EXTRACTED.
C                         IF NEGATIVE , THE ABSOLUTE VALUE IS POSITION OF
C                         'SEPARATOR' ENCOUNTERED .
C                     K - INTEGER VALUE IN WORD K OF 'KINT'. MISSING DATA
C                         VALUE INSERTED IF '/' OR NON DIGIT ENCOUNTERED.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTINT ( I,N,K )*
C
C     AUTHOR.
C     -------
C
C          J. HENNESSY
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION ILET(11),IFIG(11)
C
      DATA (ILET(J),J=1,11) /
C        E    O,   P,   Q,   R,   T,   U,   W,   X,   Y,   I.
     C  69,  79,  80,  81,  82,  84,  85,  87,  88,  89,  73 /
C
      DATA (IFIG(J),J=1,11) /
C        3    9,   0,   1,   4,   5,   7,   2,   /,   6,   8.
     C  51,  57,  48,  49,  52,  53,  55,  50,  47,  54,  56 /
C
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT N FIGURES.
C                ------------------
 100  CONTINUE
C
      IAC = 0
      IA = IABS(I)
      IB = IA + N - 1
C
C*           1.1 STORE KCHAR(J) SO THAT IT WONT BE ALTERED IN THE SUBROUTINE.
C                ------------------------------------------------------------
 110  CONTINUE
C
      DO 111 J=IA,IB
C
      KTEMP=KCHAR(J)
      KTEMP=KCHAR(J)
      KAR = KCHAR(J) .AND. 127
C
C
C          CHECK FOR SPACE,LINE FEED AND CARRIAGE RETURN CHARACTER .
C
           IF ( KAR .EQ. 32 .OR. KAR .EQ. 10 .OR. KAR .EQ. 13)
     C                           THEN
                                      I = - J
                                      KINT(K) = MINDIC
                                      RETURN
                                 END IF
C
C          CHECK FOR / CHARACTER .
C
           IF ( KAR.EQ.47 ) THEN
                                     I = IB + 1
                                     KINT(K) = MINDIC
                                     RETURN
                                  END IF
C
C          IF LETTER ENCOUNTERED CONVERT TO FIGURE USING THE
C          CCITT NO.2 LETTER/FIGURE RELATIONSHIP.
C
           IF ( KAR .LT. 48 .OR. KAR .GT. 57 )
     C                      THEN
                                  DO 112 JA=1,11
                                       IF ( KAR .EQ. ILET(JA))
     C                                       KAR = IFIG(JA)
  112                             CONTINUE
                           END IF
C
           IF ( KAR .GE. 48 .AND. KAR .LE. 57 )
     C                             THEN
                                    IAC = (IAC + (KAR.AND.15))*10
                                   ELSE
                                      KINT(K) = MINDIC
                                      I = IB + 1
                                      RETURN
                                   END IF
C
C
C
      KCHAR(J)=KTEMP
C
  111 CONTINUE
C
      KINT(K) = IAC / 10
      I = J
C
C
      RETURN
      END
      
      SUBROUTINE NEXTPRT ( I,J )
C
C**** *NEXTPRT*
C
C
C     PURPOSE.
C     --------
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER. I > J INDICATES
C                         CHARACTER NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTSEP ( I,J )
C
C**** *NEXTSEP*
C
C
C     PURPOSE.
C     --------
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C                        'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTSEP(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTEND ( I,J )
C
C**** *NEXTEND*
C
C
C     PURPOSE.
C     --------
C         FUNCTION  : LOCATE NEXT OCCURRENCE OF EITHER 'CR' OR 'LF'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' CHARACTER.
C                     I > J INDICATES NO CHARACTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTEND(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'CR' = 13 , 'LF' = 10 .
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. 13 .OR. KAR .EQ. 10 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTBULL ( I,M )
C
C**** *PRTBULL*
C
C
C     PURPOSE.
C     --------
C         PRINTS BULLETIN IN ARRAY 'KCHAR'
C
C         INPUT      : BULLETIN IN 'KCHAR' .
C                      I - PRINT STARTS AT CHARACTER I
C                      M - PRINT ENDS AT CHARACTER M .
C
C         OUTPUT     : BULLETIN IS PRINTED . ARRAY 'KCHAR' AND POINTERS
C                      UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTBULL(I,M)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *NEXTPRT(I,J)*
C         *CALL* *NEXTEND(I,J)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c          R.CINTRA   *CPTEC*
C
C
C      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION LINE(80)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT BULLETIN.
C                ---------------
 100  CONTINUE
C
      IP = I
      J = M
      K = 80
C
C*          1.1  SET OUTPUT LINE TO ALL SPACES .
C                -------------------------------
 110  CONTINUE
C
      DO 111 N=1,K
             LINE(N) = 32
  111 CONTINUE
C
C     LOCATE START AND END OF NEXT LINE OF CHARACTERS ( IF ANY ).
C
      CALL NEXTPRT ( IP,J )
      IF ( IP.GT.J ) RETURN
      JP = IP
      CALL NEXTEND ( JP,J )
      K = JP - IP
C
C     INSERT IN OUTPUT LINE and suppress parity bit.
C
      DO 112 N =1,K
             LINE(N) = KCHAR(IP).AND.127
             IP = IP + 1
  112 CONTINUE
C
      WRITE ( *,9900) (LINE(N),N=1,K)
C
C     GET NEXT LINE
C
      GO TO 110
C
 9900 FORMAT (1H ,80A1)
C
      END
      
      SUBROUTINE INITVAR ( IERR )
C
C**** *INITVAR*
C
C
C     PURPOSE.
C     --------
C         DECLARATION OF COMMON AREAS AND INITIALISATION OF
C         VARIABLES.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *INITVAR(IERR)*
C
C           IERR - SET TO 0 .
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      CHARACTER *10 IFA
      CHARACTER CTABBEN*64,CTABBU*24
      CHARACTER*8 YDATE
C
      INCLUDE 'parameter.h'
      INCLUDE 'combuff.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comtab.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      include 'comdate.h'
C
C     ------------------------------------------------------------------
C           1.   INITIALISE MISSING DATA INDICATOR.
C                ----------------------------------
 100  CONTINUE
C
      DATA MINDIC / '17777777777'O /
      OPS2=.TRUE.
      NSUB=0
C     -------------------------------------------------------------------
C*          2.   INITIALIZE DEFAULT VALUES FOR ERROR HANDLING OPTIONS.
C                ------------------------------------------------------
 200  CONTINUE
C                'IOPTS' CONTAINS 1 WORD FOR ANY POSSIBLE
C                 BULLETIN TYPE FROM 'TT' OF 'AA' TO 'ZZ' .
C                 BIT SETTINGS HAVE THE FOLLOWING MEANING.
C                 BITS ARE NUMBERED LEFT TO RIGHT , 59 TO 0 .
C
C                 BIT N  = 1 MEANS REPORT WITH ERROR NUMBER N+1 IS TO BE
C                            WRITTEN TO THE ERROR FILE .
C                          0 MEANS REPORT NOT TO BE WRITTEN TO ERROR FILE.
C
C
C
C
C                 WORDS 677 AND 678 DEFINE DEFAULT OPTIONS FOR HANDLING OF
C                 BULLETIN ERRORS.
C
C                 WORD 678 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      WRITTEN TO THE ERROR FILE.
C                 WORD 677 : BIT N = 1 MEANS BULLETIN WITH ERROR N+1 IS TO BE
C                                      PRINTED.
C                 NO ACTION IF BIT N = 0 .
C
C
C                 DEFAULT FOR HANDLING REPORT ERRORS IS TO WRITE
C                 ALL REPORTS WITH ERRORS TO THE ERROR FILE.
C
C                 DEFAULT BULLETIN HANDLING IS TO DISCARD 'NIL' BULLETINS ,
C                 SHORT ( LESS THAN 3 LINES ) BULLETINS AND NATIONAL
C                 BULLETINS FROM UK AND FRG. BULLETINS IN ERROR ARE NOT
C                 PRINTED.
C
      DATA IOPTS / 676*'37777777777'O,'0'O,'2'O /
C
C     -------------------------------------------------------------------
C*          3.    CLEAR COUNTERS.
C                 ---------------
 300  CONTINUE
C
C                 NUMBULL : NUMBER OF BULLETINS HANDLED BY DECODING RUN.
C                 NUMBERR : NUMBERS OF BULLETIN ERRORS.
C                 NOER    : NUMBERS OF REPORT ERRORS.
C                 NUMREP  : NUMBERS OF REPORTS HANDLED BY DECODING RUN.
C
      DATA NUMBULL / 0 /
      DATA NUMREP /26*0/
      DATA NUMBERR / 8*0 /
      DATA NOER /1560*0/
      DATA NUMRERR /26*0/
      DATA IMPSTA/2000*0/
      DATA IGRIBS /0/
C
C     -------------------------------------------------------------------
C*          4.   SET END OF FILE INDICATOR.
C                ---------------------------
 400  CONTINUE
C
      DATA IEOF / 0 /
C     -------------------------------------------------------------------
C*          5.   INITIALIZE ERROR INDICATOR.
C                ---------------------------
 500  CONTINUE
C
      IERR = 0
C     -----------------------------------------------------------------
C*          6.   SET UP NUMBER OF BITS PER COMPUTER WORD.
C                ----------------------------------------
 600  CONTINUE
C
      NBPW=32
C     -----------------------------------------------------------------
C*          7.   SET UP BIT MASKS.
C                -----------------
 700  CONTINUE
C
      DATA ( MASKS(J),J=1,32)/
     1                             '1'O,                      '3'O,
     2                             '7'O,                     '17'O,
     3                            '37'O,                     '77'O,
     4                           '177'O,                    '377'O,
     5                           '777'O,                   '1777'O,
     6                          '3777'O,                   '7777'O,
     7                          '7777'O,                  '37777'O,
     8                         '77777'O,                 '177777'O,
     9                        '377777'O,                 '777777'O,
     A                       '1777777'O,                '3777777'O,
     1                       '7777777'O,               '17777777'O,
     2                      '37777777'O,               '77777777'O,
     3                     '177777777'O,              '377777777'O,
     4                     '777777777'O,             '1777777777'O,
     5                    '3777777777'O,             '7777777777'O,
     6                   '17777777777'O,            '37777777777'O  /
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR TABLE B.
C                --------------------
 800  CONTINUE
C
      CALL SETTAB( IERR )
      CALL SETWT ( IERR ) 
C     --------------------------------------------------------------------
C*          10.   SET UP date of observations.
C                -----------------------------------------------
 905  CONTINUE
C
      call datim (ny,nm,nd,nutc,nh,nmin,nsec,ncc)

      if (nm .lt. 0) nm = nm * -1     
c       print*,'initvar',ny,nm,nd          
C 
      RETURN
      END
      
      SUBROUTINE NEXTFIG ( I,K )
C
C**** *NEXTFIG*
C
C
C     PURPOSE.
C     --------
C         LOCATE FIRST WORD CONTAINING A FIGURE IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO FIGURE FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTFIG(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c	   R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT FIGURE.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 48 .AND. KAR .LE. 57 ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTLET ( I,K )
C
C**** *NEXTLET*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE FIRST WORD CONTAINING A LETTER IN ARRAY
C         'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT     : BULLETIN IN 'KCHAR' , 1 CHARACTER PER WORD.
C
C         OUTPUT    : I = REQUIRED LOCATION . I > K MEANS NO LETTER FOUND.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTLET(I,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c	   R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   FIND POINTER TO NEXT LETTER.
C                ----------------------------
 100  CONTINUE
C
C
      I = IABS(I)
      J = I
      DO 110 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .GE. 65 .AND. KAR .LE. 90 ) RETURN
  110 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C**** *EXTGRP*
C
C
C     PURPOSE.
C     --------
C         CONVERT GROUP IN THE REPORT
C         TO INTEGERS IN ARRAY 'KINT' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXTGRP ( I,N1,N2,N3,N4,N5,N,IRET )
C
C                    I - CONVERSION OF GROUP STARTS IN WORD I
C                        OF ARRAY 'KCHAR' .
C
C                    N1 - NUMBER OF CHARACTERS CONVERTED TO FIRST INTEGER
C                    N2 -    "    "     "          "     " SECOND   "
C                    N3 -    "    "     "          "     "  THIRD   "
C                    N4 -    "    "     "          "     "  FOURTH  "
C                    N5 =    "    "     "          "     "  FIFTH   "
C
C
C                    N - INDEX TO ARRAY 'KINT' , WHERE THE INSERTION OF
C                        INTEGER VALUES STARTS.
C                        VALUES ARE INSERTED IN CONSECUTIVE WORDS.
C
C                    IRET = 0 , ALL CONVERSIONS PERFORMED OK.
C                         = N , ERROR FOUND IN N TH INTEGER CONVERSION.
C
C                    I - POINTS TO CHARACTER AFTER LAST ONE EXTRACTED ,
C                        UNLESS A 'SEPARATOR' (= 'SPACE' , 'LINE FEED',
C                        'CARRIAGE RETURN') IS ENCOUNTERED IN FIGURES
C                        BEING EXTRACTED . IN THIS CASE I IS MADE NEGATIVE
C                        WITH THE ABSOLUTE VALUE OF 'I' POINTING TO THE
C                        'SEPARATOR' FOUND. IN THIS CASE ALSO THE WHOLE
C                        GROUP IS DELETED FROM 'KINT'.
C
C                        INTEGER VALUES EXTRACTED PUT IN WORDS N,N+1 ETC
C                        OF ARRAY 'KINT' .
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *EXTINT(I,N,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
c		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION NN(5)
C
C     ------------------------------------------------------------------
C*          1.   EXTRACT GROUP OF CHARACTERS.
C                ----------------------------
 100  CONTINUE
C
      NN(1) = N1
      NN(2) = N2
      NN(3) = N3
      NN(4) = N4
      NN(5) = N5
C
      IRET = 0
C
      K = N
C
C
C
C*          1.1  CONVERT GROUP .
C                ---------------
 110  CONTINUE
C
      DO 111 J=1,5
         IF ( NN(J).EQ.0 ) RETURN
         CALL EXTINT ( I,NN(J),K )
         IF ( I.LT.0 ) THEN
                            IRET = J
                               DO 50 JJ=1,5
                               IF(NN(JJ) .EQ. 0) RETURN
                               KINT(N+JJ-1) = MINDIC
50                             CONTINUE
                            RETURN
                       END IF
         K = K + 1
  111 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE ERRFILE( ihead,IERR )
C
C**** *ERRFILE*
C
C
C     PURPOSE.
C     --------
C         WRITE PROBLEM BULLETIN TO THE ERROR FILE TOGATHER WITH
C         KEY.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *ERRFILE(ihead,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C     MODIFICATIONS.
C     --------------
C
c		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      CHARACTER*1 Y63
      CHARACTER*80 YOUT,YOUTA
      CHARACTER*16384 YCHAR
      CHARACTER*3 YSPEC
C
      YSPEC=CHAR(13)//CHAR(13)//CHAR(10)
      Y63  =CHAR(63)
C     ------------------------------------------------------------------
C
C*          1.   WRITE BULLETIN TO THE ERROR FILE.
C                ---------------------------------
 100  CONTINUE
C
      J1=1
C
C*          1.1  OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 110  CONTINUE
C
      OPEN(UNIT=11,IOSTAT=IOS,ERR=400,
     C     FILE='AIRC.error.dat',
     c     STATUS='UNKNOWN',
     C     RECL=80                      )
C
C     -----------------------------------------------------------------
C*          2. initialize pointers.
C              --------------------
 200  CONTINUE
c 
      ist=1
      iend=1
c
C
C     -----------------------------------------------------------------
C*          3. WRITE BULLETIN INTO ERROR FILE AND MARK ERROR.
C              ----------------------------------------------
 300  CONTINUE
C
      YOUT=' '
      YOUTA=' '
C
      call nextend(iend,ilen)
      if(iend.gt.ilen) go to 500
      call nextprt(iend,ilen)
c      if(iend.gt.ilen) go to 500 
      iend=iend-1
c
      ii=0
c
      do 301 i=ist,iend
c
      ii=ii+1
      if(kchar(i).gt.127) then
                             youta(ii:ii)=y63
                             isign=1
                          end if
      yout(ii:ii)=char(kchar(i).and.127)

 301  continue

      iend=iend+1
      ist=iend
C
      WRITE(11,'(A)') YOUT
      if(isign.eq.1)  WRITE(11,'(A)') YOUTA
      isign=0
C
C
      GO TO 300
C
 400  CONTINUE
C
      PRINT*,' +++ ERROR DURING OPENNING UNIT 10 +++, IOS=',IOS
C
 500  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE NEXTVAL ( I,N,K )
C
C**** *NEXTVAL*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE FIRST WORD CONTAINING THE VALUE 'N' IN
C         ARRAY 'KCHAR' BETWEEN WORD 'I' AND WORD 'K' .
C
C         INPUT    : 'KCHAR' CONTAINS ONE BULLETIN , ONE CHARACTER PER
C                    WORD.
C
C         OUTPUT   : I = REQUIRED LOCATION . I > K MEANS VALUE NOT FOUND.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTVAL(I,N,K)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   EXTRACT VALUE.
C                --------------
 100  CONTINUE
C
      I = IABS(I)
      J = I
      DO 101 I=J,K
         KAR = KCHAR(I) .AND. 127
         IF ( KAR .EQ. N ) RETURN
  101 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTKDEC(IA,K,J,MINDIC)
C
C**** *PRTKDEC*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE DECODED FORMAT ARRAY (KDEC)
C         OF DECODING DATA (PHASE II).
C
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKEDEC(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KDEC' ARRAY
C                      K      - PRINT STARTS AT WORD I.
C                      J      - PRINT STOPS AT WORD J .
C                      MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/08/88.
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KDEC'.
C                -------------------
 100  CONTINUE
C
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN DECODED FORMAT ( KDEC ) ',/)
C
C
         DO 101 I=K,J,10
         I2 = I+9
C
            DO 102 JJ=I,I2
            IF(IA(JJ) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 JJ=I2,J
                       IF(IA(JJ) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         IF(I .EQ. 1)  WRITE(*,30000) I,(IA(IK),IK=I,I2)
         IF(I .EQ. 11) WRITE(*,40000) I,(IA(IK),IK=I,I2)
         IF(I .GT. 20) WRITE(*,50000) I,(IA(IK),IK=I,I2)
30000    FORMAT(1H ,2X,I4,4X,6(I10,1X),6X,A4,1X,3(I10,1X))
40000    FORMAT(1H ,2X,I4,4X,2(I10,1X),O10,1X,I10,1X,O10,1X,2(I10,1X),
     C          2(I10,1X),I10)
50000    FORMAT(1H ,2X,I4,4X,10(I10,1X))
C
101      CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRTKINT(IA,K,kl,MINDIC)
C
C**** *PRTKINT*
C
C
C     PURPOSE.
C     --------
C         PRINTS THE INTERMEDIATE FORMAT ARRAY (KINT)
C         OF DECODING DATA (PHASE II).
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRTKINT(IA,K,J,MINDIC)*
C
C         INPUT     : IA     - THE 'KINT' ARRAY
C                     K      - PRINT STARTS AT WORD I.
C                     kl      - PRINT STOPS AT WORD J .
C                     MINDIC - MISSING VALUE INDICATOR
C
C     MODIFICATIONS.
C     --------------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      DIMENSION IA(1)
C
C     ------------------------------------------------------------------
C
C*          1.   PRINT ARRAY 'KINT'.
C                -------------------
 100  CONTINUE
C
C
      LODATA = .TRUE.
      LODOT = .TRUE.
C
C
      WRITE(*,10000)
10000 FORMAT(1H ,2X,'  DATA IN INTERMEDIATE FORMAT ( KINT ) ',/)
C
C
         DO 101 I=K,kl,10
         I2 = I+9
C
            DO 102 J=I,I2
            IF(IA(J) .EQ. MINDIC) GO TO 102
            LODATA = .FALSE.
102         CONTINUE
C
         IF(LODATA) THEN
C
C                      CHECK IF THERE ARE MORE DATA
C
                       DO 103 J=I2,kl
                       IF(IA(J) .EQ. MINDIC) GO TO 103
                       GO TO 104
103                    CONTINUE
                       RETURN
C
104                    CONTINUE
C
                       IF(LODOT) THEN
                                    WRITE(*,20000)
20000                               FORMAT(1H ,3X,'---',/1H ,3X,'---')
                                    LODOT = .FALSE.
                                 END IF
                       GO TO 101
                    END IF
C
         LODOT = .TRUE.
         LODATA = .TRUE.
C
         WRITE(*,30000) I,(IA(J),J=I,I2)
30000    FORMAT(1H ,2X,I4,2X,10(I10,1X))
C
C
101      CONTINUE
C
      RETURN
      END
      
      SUBROUTINE EXBAIR( IERR )
C
C**** *EXBAIR*
C
C
C     PURPOSE.
C     --------
C         SET UP BUFR EXPANDED FORMAT FOR AIREP DATA.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *EXBAIR( IERR )*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *GBYTE(        )*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comtab.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comident.h'
C
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h'
C
      CHARACTER*9 CVAL,CIDENT 
      character*24 cunit
C
      INCLUDE 'comwtc.h'      ! CONTAIN CVAL ARRAY
      INCLUDE 'comair.h'      ! AICRAFT FLIGHT PHASE
C
C     ------------------------------------------------------------------
C*          1.   INCREASE SUBSETS COUNTER BY ONE.
C                ----------------------------------
 100  CONTINUE
C
      if (ierr .ne. 0) return
      NSUB=NSUB+1
C------------------------------------------------------------------------
c     a atribuicao para N parou de funcionar talvez por uma alteracao 
c     do compilador FORTRAN
c               -------VERIFICAR OS PROXIMOS RELEASES------
C------------------------------------------------------------------------
      NS=NSUB
      CVAL(NSUB)=' '
C
C*          1.1  GET CURRENT DATE(MONTH AND YEAR).
C                --------------------------------- 
 110  CONTINUE
C
      CALL DATUM(KDEC(1),IMONTH,IYEAR)
C     ------------------------------------------------------------------
C*          2.   AIRCRAFT IDENTIFIER.
C                --------------------
 200  CONTINUE
C
      VALUES(1,NSUB)=NSUB*1000+8
      CVAL(NSUB)=CHAR(IDENT(1))//CHAR(IDENT(2))//CHAR(IDENT(3))//
     1           CHAR(IDENT(4))//CHAR(IDENT(5))//CHAR(IDENT(6))//
     2           CHAR(IDENT(7))//CHAR(IDENT(8))
C
C*          2.1  AIRCRAFT NAVIGATIONAL SYSTEM.
C                -----------------------------
 210  CONTINUE
C
      VALUES(2,NSUB)=999999.
C
C*          2.2  SET UP YEAR.
C                ------------
 220  CONTINUE
C
      VALUES(3,NSUB)=float(IYEAR)
C
C*          2.3  SET UP MONTH
C                ------------
 230  CONTINUE
C
      VALUES(4,NSUB)=FLOAT(IMONTH)
C
C*          2.4  SET UP DAY.
C                -----------
 240  CONTINUE
C
      VALUES(5,NSUB)=FLOAT(KDEC(1))
C
C*          2.5  SET UP HOUR.
C                ------------
 250  CONTINUE
C
      VALUES(6,NSUB)=FLOAT(KDEC(2))
C
C*          2.6  SET UP MINUTE.
C                --------------
 260  CONTINUE
C
      VALUES(7,NSUB)=float(KDEC(9))
C
C*          2.7  SET UP LATITUDE.
C                ----------------
 270  CONTINUE
C
      VALUES(8,NSUB)=FLOAT(KDEC(5))/100.
C
C*          2.8  SET UP LONGITUDE.
C                -----------------
 280  CONTINUE
C
      VALUES( 9,NSUB)=FLOAT(KDEC(6))/100.
C
C     ------------------------------------------------------------------
C*          3.  PHASE OF AIRCRAFT FLIGHT.
C               -------------------------
 300  CONTINUE
C
      VALUES(10,NSUB)=FLOAT(NPHASE)
C
C*          3.1  HEIGHT OR ALTITUDE.
C                -------------------
 310  CONTINUE
C
      VALUES(11,NSUB)=FLOAT(KDEC(8))
C
C*          3.2  TEMPERATURE.
C                ------------
 320  CONTINUE
C
      VALUES(12,NSUB)=999999.
      IF(KDEC(26).NE.MINDIC)
     1   then
            VALUES(12,NSUB)=FLOAT(KDEC(26))/10.+273.16
         end if
C
C*          3.3  WIND DIRECTION.
C                ---------------
 330  CONTINUE
C
      VALUES(13,NSUB)=999999.
      IF(KDEC(27).NE.MINDIC) VALUES(13,NSUB)=FLOAT(KDEC(27))
C
C*          3.4  WIND SPEED.
C                -----------
 340  CONTINUE
C
      VALUES(14,NSUB)=999999.
      IF(KDEC(28).NE.MINDIC) VALUES(14,NSUB)=FLOAT(KDEC(28))
C
C*          3.5  DEGREE OF TURBULENCE.
C                ---------------------
 350  CONTINUE
C
      VALUES(15,NSUB)=999999.
C
C*          3.6  HEIGHT OF BASE OF TURBULENCE.
C                -----------------------------
 360  CONTINUE
C
      VALUES(16,NSUB)=999999.
C
C*          3.7  HEIGHT OF TOP OF TURBULENCE.
C                ----------------------------
 370  CONTINUE
C
      VALUES(17,NSUB)=999999.
C     ------------------------------------------------------------------
C*          3.8  AIRFRAME ICING.
C                ---------------
 380  CONTINUE
C
      VALUES(18,NSUB)=999999.
C
C     ------------------------------------------------------------------
C*          3.9  SET NUMBER OF ELEMENTS.
C                -----------------------
 390  CONTINUE
C
      M=18
C
C     ------------------------------------------------------------------
C*          4.   SET INFORMATION NEEDED FOR RDB KEY DEFINITION.
C                ----------------------------------------------
 400  CONTINUE
C
      NBUFTYPE=4                         ! SINGLE LEVEL UPPER-AIR(NON SAT)
      NTYPE=7                            ! RDB TYPE NUMBER
      IF(KDEC(4).EQ. 41) NSBTYPE=141     ! CODAR
      IF(KDEC(4).EQ.141) NSBTYPE=142     ! AIREP 
      IF(KDEC(4).EQ.241) NSBTYPE=143     ! COLBA
      IF(KDEC(4).EQ.144) NSBTYPE=144     ! AMDAR
C
      NYEAR =IYEAR
      NMONTH=IMONTH
      NDAY  =KDEC(1)
      NHOUR =KDEC(2)
      NMINUTE=KDEC(9)
      NSECOND=0
C
      JSCALE=5
      JREFLAT= -9000000
      JREFLON=-18000000
C
      NLAT1=NINT(VALUES(8,NSUB)*10.**JSCALE)-JREFLAT
      NLON1=NINT(VALUES(9,NSUB)*10.**JSCALE)-JREFLON
C
      NLAT2=0  
      NLON2=0
C
      NOBS=NSUB
C
      CIDENT= CVAL(NSUB)
      NRECR=1
      NCORR=KDEC(21)
      NNIL=0
C
C     -----------------------------------------------------------------
      RETURN
      END
      
      SUBROUTINE BUFRENC( IERR )
C
C**** *BUFRENC*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO ENCODE INDIVIDUAL TOVS
C         REPORT FROM FULLY EXPANDED BUFR FORMAT INTO BUFR MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *BUFRENC(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C         *CALL* *SEC1(IERR)*
C         *CALL* *SEC2(IERR)*
C         *CALL* *SEC3(IERR)*
C         *CALL* *SEC4(IERR)*
C         *CALL* *SEC5(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comwt.h'
C
C     ------------------------------------------------------------------
C*          1.   SET UP *BUFR* MESSAGE.
C                ----------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  SET UP SECTION 0.
C                -----------------
 110  CONTINUE
C
      CALL SEC0( IERR )
C
C*          1.2  SET UP SECTION 1.
C                -----------------
 120  CONTINUE
C
      CALL SEC1( IERR )
C
C*          1.3  SET UP SECTION 2.
C                -----------------
 130  CONTINUE
C
      CALL SEC2( IERR )
C
C*          1.4  SET UP SECTION 3.
C                -----------------
 140  CONTINUE
C
      CALL SEC3( IERR )
C
C*          1.5  SET UP SECTION 4.
C                -----------------
 150  CONTINUE
C
      CALL SEC4( IERR )
C
C*          1.6  SET UP SECTION 5.
C                -----------------
 160  CONTINUE
C
      CALL SEC5( IERR )
C
C*          2.   PUT BUFR MESSAGE INTO RDB.
C                --------------------------
 200  CONTINUE
C
      CALL PUTBUFR( IERR )
C
C
C*          2.1  RESET NUMBER OF SUBSETS TO 0.
C                -----------------------------
 210  CONTINUE
C
      NSUB=0
C     ------------------------------------------------------------------
C
      RETURN
      END
      
      SUBROUTINE SEC0( IERR )
C
C**** *SEC0*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 0 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC0(IERR)*
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C 		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 0 ( INDICATOR SECTION )
C                --- --  ------- -   --------- -------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 -------------------------------------------------------
 110  CONTINUE
C
      NWPT= 2
      NBPT= 0
C
C     B IS CCITT.5 DECIMAL 66
C     U IS CCITT.5 DECIMAL 85
C     F IS CCITT.5 DECIMAL 70
C     R IS CCITT.5 DECIMAL 82
C
      CALL PACK(NBPW,MBUF(NWPT),66,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),85,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),70,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),82,NWPT,NBPT,8)
c
c          Bufr Message lenght
c
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C            Bufr Edition 2
C
      CALL PACK(NBPW,MBUF(NWPT), 2,NWPT,NBPT,8)
C
      RETURN
      END
      
      SUBROUTINE SEC1( IERR )
C
C**** *SEC1*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 1 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC1(IERR)*
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. Dragosavac 13/11/1991  : change to Bufr Edition 2
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 1 ( IDENTIFICATION SECTION).
C                --------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0) RETURN
C     ------------------------------------------------------------------
C*          2.   KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 200  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          3.   SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 300  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          4.   BUFR MASTER TABLE( ZERO IF STANDARD WMO FM - 94 USED
C                ----------------------------------------------------
 400  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          5.   SET UP ORIGINATING CENTRE.
C                --------------------------
 500  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),46,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          6.   SET UP UPDATE SEQUENCE NUMBER.
C                ------------------------------
 600  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C
C     ------------------------------------------------------------------
C*          7.   SET UP PRESENCE OF SECTION 2.
C                -----------------------------
 160  CONTINUE
C
      IPS2=0
      IF(OPS2) IPS2=128
      CALL PACK(NBPW,MBUF(NWPT),IPS2,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.7  SET UP BUFR MESSAGE TYPE.
C                -------------------------
 700  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NBUFTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          8.   SET UP BUFR MESSAGE SUB-TYPE.
C                -----------------------------
 800  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NSBTYPE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          9.   VERSION NUMBER OF MASTER TABLE USED.
C                ------------------------------------
 900  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT,8)
C
C*          9.1  VERSION NUMBER OF LOCAL TABLES USED.
C                ------------------------------------
 910  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          10.  SET UP YEAR OF CENTURY.
C                -----------------------
 1000 CONTINUE
C
      iyear=values(3,1)
      icen = (iyear * .01)
      IYEAR=iYEAR - (icen * 100.)
      if (iyear.eq.0) iyear=100      
      CALL PACK(NBPW,MBUF(NWPT),IYEAR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          11.  SET UP MONTH.
C                -------------
 1100 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMONTH,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          12.  SET UP DAY.
C                -----------
 1200 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NDAY,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          13.  SET UP HOUR.
C                -------------
 1300 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NHOUR,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          14.  SET UP MINUTE.
C                --------------
 1400 CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),NMINUTE,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          15.  SET UP LENGTH OF THE SECTION 1.
C                --------------------------------
 1500 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
C
 1600 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC5( IERR )
C
C**** *SEC5*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 5 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC5(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 5 ( END SECTION ).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C*          1.1  IT IS FOUR OCTETS LONG CHARACTER CODED ACCORDING TO THE
C                -------------------------------------------------------
C                *INTERNATIONAL *TELEGRAPHIC *ALPHABET *NO. 5 AS *BUFR*.
C                 ------------------------------------------------------
 110  CONTINUE
C
C
C     7 IS CCITT.5 DECIMAL 55
C
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
      CALL PACK(NBPW,MBUF(NWPT),55,NWPT,NBPT,8)
C
C                                                                       
C*          1.3  SET TOTAL LENGTH OF BUFR MESSAGE.
C                ---------------------------------
 130  CONTINUE
C
      IBYTES=(NWPT-2)*NBPW/8+NBPT/8
C
C*          1.4  SET TOTAL LENGTH OF BUFR MESSAGE IN SECTION 0.
C                ----------------------------------------------
 140  CONTINUE
C
C        FOR BUFR EDITION 2 LENGTH OF MESSAGE STARTS AT 5 TH BYTE.
C
      IWPT= 32/NBPW + 2
      IBPT= 32 - (IWPT-1)* NBPW
      ibpt = 0
C
      CALL PACK(NBPW,MBUF(IWPT),IBYTES,IWPT,IBPT,24)
C
      RETURN
      END
      
      SUBROUTINE SEC2( IERR )
C
C**** *SEC2*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 2 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC2(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 2 ( OPTIONA SECTION).
C                -------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
      IF(.NOT. OPS2 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---- -------- -- --- -------- -- --- -------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP RDB KEY ( 48 BYTES ).
C                ----------------------------
 140  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,32)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP LENGTH OF THE SECTION 2.
C                ------------------------------
 150  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SEC3( IERR )
C
C**** *SEC3*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 3 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC3(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 3 ( DATA DESCRIPTION SECTION ).
C                -----------------------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.4  SET UP NUMBER OF DATA SUB-SETS.
C                -------------------------------
 140  CONTINUE
C
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      CALL PACK(NBPW,MBUF(NWPT),NS,NWPT,NBPT,16)
C
C     ------------------------------------------------------------------
C*          1.5  SET UP INFORMATION ABOUT TYPE OF DATA AND COMPRESSION.
C                ------------------------------------------------------
 150  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),128,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          1.6  SET UP COLLECTION OF DESCRIPTORS TO DEFINE DATA.
C                --------------------------------------------------
 160  CONTINUE
C
C     ASDAR/AIREP
C
      MQ=18
      CALL PACK(NBPW,MBUF(NWPT),3,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),11,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 8)
C
C     CHECK IF Q/C PERFORMED.
C
      IBIT1=0
      DO 161 I=M+1,M+M
         IF(VALUES(I,NSUB).NE.999999.) IBIT1=IBIT1+1
 161  CONTINUE
C
      IF(IBIT1.EQ.0) GO TO 170
C
      MQ=22
      CALL PACK(NBPW,MBUF(NWPT),2,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),22,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),M,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),31,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),201,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),1,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),IBIT1,NWPT,NBPT, 8)
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT, 2)
      CALL PACK(NBPW,MBUF(NWPT),33,NWPT,NBPT, 6)
      CALL PACK(NBPW,MBUF(NWPT),7,NWPT,NBPT, 8)
C     ------------------------------------------------------------------
C*          1.7  SET UP LENGTH OF THE SECTION 3.
C                -------------------------------
 170  CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 200  CONTINUE
C
      RETURN
      END
      SUBROUTINE SEC4( IERR )
C
C**** *SEC4*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET UP SECTION 4 OF *BUFR
C         MESSAGE.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SEC4(IERR)*
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C         *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C            *KWPTB* - POINTER TO WORD AT BEGINING OF SECTION.
C            *KBPTB* - POINTER TO BIT ISIDE THE WORD.
C
C         *CALL* *GBYTE(KS,KD,KSKI,KSI)
C
C            *KS*    - SOURCE
C            *KD*    - DESTINATION
C            *KSKI*  - NUMBER OF BITS TO BE SKIPPED
C            *KSI*   - NUMBER OF BITS TO BE EXTRACTED
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
C
      CHARACTER*24 CUNIT,YUNIT
      CHARACTER*9 CVAL,YVAL
C
      INCLUDE 'comwtc.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SET UP *SECTION 4 ( DATA SECTION).
C                ----------------------------------
 100  CONTINUE
C
      IF( IERR.NE.0 ) RETURN
C     ------------------------------------------------------------------
C*          1.1  KEEP POINTERS TO THE BEGINING OF THE SECTION.
C                ---------------------------------------------
 110  CONTINUE
C
      IWPTB = NWPT
      IBPTB = NBPT
C
C     ------------------------------------------------------------------
C*          1.2  SET UP LENGTH OF SECTION (OCTET 1-3 ) TO ZERO.
C                ----------------------------------------------
 120  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,24)
C
C     ------------------------------------------------------------------
C*          1.3  SET UP RESERVED BYTE  TO ZERO.
C                ------------------------------
 130  CONTINUE
C
      CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,8)
C
C     ------------------------------------------------------------------
C*          2.   SET UP BINARY DATA AS DEFINED BY SEQUENCE DESCRIPTOR.
C                ------------------------------------------------
 200  CONTINUE
C
C
c          ---- verificar a variavel a que foi atribuida  NSUB ----

      DO 201 I=1,NS
      DO 202 J=1,M
C
      IREF  =IWTRV(J)
      ISCALE=IWTS (J)
      IBDW  =IWTDW(J)
      YUNIT =CUNIT(J)
C
      VAL=VALUES(J,I)
C
      IF(YUNIT.EQ.'CCITTIA5') THEN
         IST=NINT(VAL)/1000
         YVAL=CVAL(IST)
         NCHAR=NINT(VAL)-IST*1000
         DO 203 II=1,NCHAR
         IPACK=ICHAR(YVAL(II:II))
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,8)
 203     CONTINUE
         GO TO 202
      END IF
C
      IF(VAL.EQ.999999.) THEN
         CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
      ELSE
         IF(ISCALE.LT.0) THEN
            ISCALE=IABS(ISCALE)
            IPACK=NINT(VAL/10**ISCALE) - IREF
         ELSE
            IPACK=NINT(VAL*10**ISCALE) - IREF
         END IF
C
         CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
      END IF
C
 202  CONTINUE
C
      IF(M.LT.MQ) THEN
C
        DO 210 J=M+1,MQ      
C
        IREV  =IWTR (J)
        IREF  =IWTRV(J)
        ISCALE=IWTS (J)
        IBDW  =IWTDW(J)
        YUNIT =CUNIT(J)
C
        IF(IREV.EQ.31031) THEN
C 
C          SET BIT FLAG
C
           IBIT1=0
C
           DO 215 JI=M+1,M+M
C
           IPACK=1
           IF(VALUES(JI,I).NE.999999.) IPACK=0
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,1)
C
 215       CONTINUE
C           
        END IF
C
        IF(IREV.EQ.1031) THEN
           VAL=46.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
C
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.1032) THEN
           VAL=999999.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
C
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.1201) THEN
           VAL=1.
           IF(VAL.EQ.999999.) THEN
              CALL PACK(NBPW,MBUF(NWPT),MASKS(IBDW),NWPT,NBPT,IBDW)
           ELSE
              IF(ISCALE.LT.0) THEN
                 ISCALE=IABS(ISCALE)
                 IPACK=NINT(VAL/10**ISCALE) - IREF
              ELSE
                 IPACK=NINT(VAL*10**ISCALE) - IREF
              END IF
C
              CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
           END IF
        END IF 
C
        IF(IREV.EQ.33007) THEN
           DO 216 JI=M+1,M+M
           VAL=VALUES(JI,I)
           IF(VAL.EQ.999999.) GO TO 216
C
           IF(ISCALE.LT.0) THEN
              ISCALE=IABS(ISCALE)
              IPACK=NINT(VAL/10**ISCALE) - IREF
           ELSE
              IPACK=NINT(VAL*10**ISCALE) - IREF
           END IF
C
           CALL PACK(NBPW,MBUF(NWPT),IPACK,NWPT,NBPT,IBDW)
C
 216       CONTINUE
C
        END IF
C
 210    CONTINUE
C
      END IF
C
 201  CONTINUE
C
C     ------------------------------------------------------------------
C*         22.   SET UP LENGTH OF THE SECTION 4.
C                -------------------------------
 2200 CONTINUE
C
      CALL OCTNUM(IWPTB,IBPTB)
C
C     ------------------------------------------------------------------
 2300 CONTINUE
C
      RETURN
      END

      SUBROUTINE SETTAB( IERR )
C
C**** *SETTAB*
C
C
C     PURPOSE.
C     --------
C         PURPOSE OF THIS ROUTINE IS TO SET *BUFR *TABLES *B.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETTAB(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       17/09/87.
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      PARAMETER(JSUP =   9,JSEC0=   3,JSEC1= 40,JSEC2= 64 ,JSEC3=    4,
     1          JSEC4=   2,JELEM=20000,JSUBS=400,JCVAL=150 ,JBUFL= 8192,
     2          JBPW =  32,JTAB =1000,JCTAB=120,JCTST=1800,JCTEXT= 200,
     3          JWORK=80000,JKEY=46) 
     
      COMMON /BCOMTAB/ NTABBTR(JTAB),NTABBS (JTAB),NTABBRV(JTAB),
     1                NTABBDW(JTAB),NTABDTR(JTAB),NTABDST(JTAB),
     2                NTABDL (JTAB),NTABDSQ(JTAB*20),NTABP(64,255)
C
C             NTABBTR    - table B,  table reference              array
C             NTABBS     - table B,  scale                        array
C             NTABBRF    - table B,  reference value              array
C             NTABBDW    - table B,  data width                   array
C             NTABDTR    - table D,  table reference              array
C             NTABDST    - table D,  starting pointers            array
C             NTABDL     - table D,  lengths                      array
C             NTABDSQ    - table D,  list of sequence descriptors array
C
C
      COMMON /BCOMTABC / CTABBEN(JTAB),CTABBU (JTAB)
C
C             CTABBEN      -  table B, ELEMENT NAME           array
C             CTABBU       -  table B, unit                   array
C
C
C      COMMON /BCOMCT/ NREF(JCTAB)   ,NSTART(JCTAB) ,NLEN(JCTAB),
C     1               NCODNUM(JCTST),NSTARTC(JCTST),
C     2               NLENC(JCTST)
C
C             NREF      - table C reference
C             NSTART    - starting pointers to array NCODNUM
C             NLEN      - lengths
C             NCODNUM   - code/flag table number
C             NSTARTC   - starting pointers to array CTEXT
C             NLENC     - lengths
C
C
C      COMMON /BCOMCTC/ CTEXT(JCTEXT)
C
C             CTEXT     - text in code/flag tables
C
C
      COMMON /BCOMROOT/ CROOT
C
C            CROOT    -  path for Bufr tables
C
C
      CHARACTER*256 YTAB ,YTAC ,YTAD
      CHARACTER*11  YTABB,YTABC,YTABD
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64
      CHARACTER*256 CROOT
C     ------------------------------------------------------------------
C
C*          1.   GET BUFR TABLES/LOCAL BUFR TABLES.
C                ----------------------------------
 100  CONTINUE
C
      IF( KERR.NE.0) RETURN
C
C*          2.   SET UP BUFR TABLE FILE NAME.
C                ----------------------------
 200  CONTINUE
C
C
C             BUFR EDITION 2 NAMING CONVENTION
C
C             BXXXXXYYZZ , CXXXXXYYZZ , DXXXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             XXXXX  - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C             BUFR EDITION 3 NAMING CONVENTION
C
C             BWWWXXXYYZZ , CWWWXXXYYZZ , DWWWXXXYYZZ
C
C             B      - BUFR TABLE 'B'
C             C      - BUFR TABLE 'C'
C             D      - BUFR TABLE 'D'
C             WWW    - ORIGINATING SUB-CENTRE
C             XXX    - ORIGINATING CENTRE
C             YY     - VERSION NUMBER OF MASTER TABLE
C                      USED( CURRENTLY 2 )
C             ZZ     - VERSION NUMBER OF LOCAL TABLE USED
C
C
            IXX=46
            IYY=02
            IZZ=01
            IWW=0
C
         croot='./'
         NXXP=IXX
         NYYP=IYY
         NZZP=IZZ
         NWWP=IWW
C
            WRITE(YTABB,'(A1,I5.5,I2.2,I2.2)') 'B',IXX,IYY,IZZ
C            WRITE(YTABC,'(A1,I5.5,I2.2,I2.2)') 'C',IXX,IYY,IZZ
            WRITE(YTABD,'(A1,I5.5,I2.2,I2.2)') 'D',IXX,IYY,IZZ
C
c         PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABC,',',YTABD
          PRINT*,'BUFR Tables to be loaded ',YTABB,',',YTABD
C
C     ----------------------------------------------------------------
C*          3. OPEN AND READ FILES CONTAINING BUFR TABLES.
C              -------------------------------------------
 300  CONTINUE
C
      I=INDEX(CROOT,' ')
      IF(I.GT.1) I=I-1
C
C*          3.1 READ BUFR TABLE B.
C               ------------------
 310  CONTINUE
C
      YTAB=CROOT(1:I)//YTABB
      II=I+11
C
      OPEN(UNIT=38,IOSTAT=IOS,ERR=410,FILE=YTAB(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(38,ERR=400,IOSTAT=IOS) NTABBTR,CTABBEN,CTABBU,NTABBS,
     1                            NTABBRV,NTABBDW,NTABP
C
      CLOSE(UNIT=38,IOSTAT=IOS,ERR=420)
C
C*          3.3 READ BUFR TABLE D.
C               ------------------
      
 330  CONTINUE
C
      YTAD=CROOT(1:I)//YTABD
C
      OPEN(UNIT=40,IOSTAT=IOS,ERR=610,FILE=YTAD(1:II),
     1     FORM='UNFORMATTED',
     2     ACCESS='SEQUENTIAL',
     5     STATUS='OLD')
C
      READ(40,ERR=600,IOSTAT=IOS) NTABDTR,NTABDL,NTABDST,NTABDSQ
C
      CLOSE(UNIT=40,IOSTAT=IOS,ERR=620)
C
C
      RETURN
C     ----------------------------------------------------------------
      
C
 400  CONTINUE
C
      KERR=6
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 410  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 420  CONTINUE
C
      KERR=10
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
 600  CONTINUE
C
      KERR=8
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 610  CONTINUE
C
      KERR=9
      PRINT*,'SETTAB: IOS ',IOS
      RETURN
C
 620  KERR=12
      PRINT*,'BUGBTS: IOS ',IOS
      RETURN
C     -----------------------------------------------------------------
C      
      end
      
      SUBROUTINE SETWT(IERR)
C
C**** *SETWT*
C
C
C     PURPOSE.
C     --------
C         SETS UP WORKING TABLE B INFORMATION.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SETWT(IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwtc.h'
      INCLUDE 'comwt.h'
C
      COMMON /BCOMTAB/ NTABBTR(Jp2),NTABBS (Jp2),NTABBRV(Jp2),
     1                NTABBDW(Jp2),NTABDTR(Jp2),NTABDST(Jp2),
     2                NTABDL (Jp2),NTABDSQ(Jp2*20),NTABP(64,255)

      COMMON /BCOMTABC / CTABBEN(jp2),CTABBU (jp2)
c
      CHARACTER    CTABBEN*64,CTABBU*24,CTEXT*64 
c
      DIMENSION ISEQ(22)
C
      DATA ISEQ  /001006,002061,004001,004002,004003
     1,           004004,004005,005001,006001,008004
     2,           007002,012001,011001,011002,011031
     4,           011032,011033,020041,031031,001031
     5,           001201,033007/
C     ------------------------------------------------------------------
C*          1.   SET UP WORKING TABLES FOR AIREP  DATA.
C                ----------------------------------------------
 100  CONTINUE
C
      DO 101 I=1,22
C
      ITR=ISEQ(I)
C
      DO 102 J=1,JP2
C
      IF(ITR.EQ.NTABBTR(J)) THEN
                               IWTR (I)=NTABBTR(J)
                               IWTS (I)=NTABBS (J)
                               IWTDW(I)=NTABBDW(J)
                               IWTRV(I)=NTABBRV(J)
c                               cunit(i)=ctabbu(j)
                               GO TO 101
                            END IF
C
 102  CONTINUE
C
      PRINT*,' BUFR TABLE B REFERENCE ENTRY',ITR,'NOT FOUND'
C
 101  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PUTBUFR( IERR )
C
C**** *PUTBUFR*
C
C
C     PURPOSE.
C     --------
C         PUT BUFR MESSAGE INTO REPORT DATA BASE.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PUTBUFR(IERR)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       15/08/88.
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      parameter (idime=16)
      INCLUDE 'comwork.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      INCLUDE 'comkeyc.h' 
      INCLUDE 'comrec.h'
      include 'comdate.h'
C
      common /recwriten/ irecswriten
      common /repetida/ irepetida
c
      CHARACTER*15000 YOUT
      CHARACTER*9  CIDENT
      CHARACTER*48 CKEY
      CHARACTER*32 YKEY
      CHARACTER*16 YTYPE,CFNAME
      CHARACTER*25 YTIME
      CHARACTER*10 CUSE
C
      CHARACTER*11 CTABNAME
      CHARACTER*17 CTSTAMP
      character*4  cstream
      character*2  ccorr 
      character*6  cc
      character*4 aux
      integer iyyy,imo,idd,iutc,ihh,imm,iss,icc
C
      character*48 records_writen(4000)
c
      DIMENSION IKEY(12)
C
      DIMENSION IFLAGS(IDIME)
C
      EQUIVALENCE (IKEY(1),YKEY,CKEY)
      EQUIVALENCE (MBUF(1),YOUT)
C
      DATA IFLAGS/1,1,1,1,1,1,2,9*0/
C
C     ------------------------------------------------------------------
C*          1. DEFINE RDB TABLE NAME.
C                ---------------------------
 100  CONTINUE
C
      IF(IERR.NE.0) RETURN
C
      IRET=0
      
c       call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
       nmonth = nm
       nday = nd
       nhour = nh
       nminute = nmin
       nsecond = nsec
c       icen = ny*.01        
c       NY=NY - (icen *100) 
      WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=101) 
     1         NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND
C
c      print*,'ytime ',ytime
      CTABNAME='AIRC_'//YTIME(1:8)
      GO TO 102
 101  CONTINUE
C
      PRINT*,' BAD DATE OR TIME, REPORT SKIPPED. IOSTAT=',IOS
      RETURN
C
 102  CONTINUE
C 
C
C*          2.  DEFINE RDB KEY AND HOUSEHEEPING INFORMATION.
C               --------------------------------------------
 200  CONTINUE
C
      IW=1
      IBT=0
C
C*          2.1 DEFINE RDB KEY.
C               ---------------
 210  CONTINUE
C 
      CALL PACK(32,IKEY(IW),NTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NSBTYPE,IW,IBT,8)
      CALL PACK(32,IKEY(IW),NYEAR,IW,IBT,12)
      CALL PACK(32,IKEY(IW),NMONTH,IW,IBT,4)
      CALL PACK(32,IKEY(IW),NDAY,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NHOUR,IW,IBT,5)
      CALL PACK(32,IKEY(IW),NMINUTE,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NSECOND,IW,IBT,6)
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)
      CALL PACK(32,IKEY(IW),NLON1,IW,IBT,26)
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)
      CALL PACK(32,IKEY(IW),NLAT1,IW,IBT,25)
      CALL PACK(32,IKEY(IW),0,IW,IBT,7)
c
c      YKEY(16:24)=CIDENT
c
c     atribuicao do identificador da estacao
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      YKEY(13:13)=CIDENT(1:1)
      YKEY(17:17)=CIDENT(5:5)
      YKEY(18:18)=CIDENT(4:4)
      YKEY(19:19)=CIDENT(3:3)
      YKEY(20:20)=CIDENT(2:2)
      YKEY(21:24)=' '
      YKEY(25:32)=' '
C
C
C*          2.2 DEFINE HOUSE KEEPING INFORMATION.      
C               ---------------------------------
 220  CONTINUE
C
      ILENGTH=(NWPT-2)*4+NBPT/8
C
C     FIND LOWEST QUALITY CONTROL PERCENTAGE. 
C
      IF(M.LT.MQ) THEN
                     RMIN=VALUES(M+1,NSUB)
                     DO 221 I=M+1,M+M
                     IF(VALUES(I,NSUB).LT.RMIN) RMIN=VALUES(I,NSUB)
 221                 CONTINUE
                     NQC=NINT(RMIN) 
                  END IF
C      
c      CALL datim(iyyy,imo,idd,iutc,ihh,imm,iss,icc)
       iyyy=ny
       imo=nm
       idd=nd
       ihh=nh
       imm=nmin
       iss=nsec
C
C     SET LENGTH OF RECORD
C
      IW =9
      IBT=0
C
      CALL PACK(32,IKEY(IW),ILENGTH,IW,IBT,16)      
C
C     SET TIME RECORD WAS LAST WRITTEN TO RDB
C 
      CALL PACK(32,IKEY(IW),IDD,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),IHH,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),IMM,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),ISS,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
C
C     SET TIME BULLETIN WAS RECEIVED
C
C
      CALL PACK(32,IKEY(IW),NRDAY,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRHOUR,IW,IBT,5)      
      CALL PACK(32,IKEY(IW),NRMIN,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRSEC,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NCORR,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),NRECR,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NNIL,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,6)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,1)      
      CALL PACK(32,IKEY(IW),NQC,IW,IBT,8)      
      CALL PACK(32,IKEY(IW),0,IW,IBT,24)      
C
C     WRITE RDB KEY INTO SECTION 2 OF BUFR MESSAGE.
C
C     WORD 8 BIT 16 (atencao meio de palavra 9)
C
c     YOUT(35:82)=CKEY(1:48)
c
c     atribuicao da chave da secao 2
c     por assinalamento de alto nivel
c     respeitando a inversao de bytes (little-endian)
c
      call invbytes(48,ckey)
      yout(34:34) = ckey(1:1)
      yout(33:33) = ckey(2:2)
c
       do 10 i = 1,44
          j = ((i-1)/4 + 10)*4 - MOD((i-1),4)
          yout(j:j) = ckey(i+2:i+2)
 10    continue
c
      yout(84:84) = ckey(47:47)
      yout(83:83) = ckey(48:48)
C
      mbuf(1)=ilength
C      
 300  CONTINUE
C
C*          3.1  WRITE REPORT INTO RDB.
C               --------------------
 310  CONTINUE
C
      ierr=0
C
C     -----------------------------------------------------------------
      call invbytes(ilength+4,yout)
      irecswriten = irecswriten + 1
      do 11 i=1,irecswriten
         if(records_writen(i)(1:48).eq.ckey(1:48)) then
           irecswriten = irecswriten - 1
	   irepetida = irepetida + 1
           go to 400
         end if
 11   continue
      records_writen(irecswriten)(1:48) = ckey(1:48)
      WRITE(99,'(a)')YOUT(5:ilength+4)
C     -----------------------------------------------------------------
 400  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE KTOMPSI(IA)
C
C**** *KTOMPSI*
C
C
C     PURPOSE.
C     --------
C
C         CONVERTS KNOTS TO METRES PER SECOND, ROUNDING
C         TO NEAREST METRE.
C
C         INPUT    :  IA WIND SPEED IN KNOTS (INTEGER)
C
C         OUTPUT   :  IA WIND SPEED IN M/S (INTEGER)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *KTOMPSI(IA)*
C
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
C
C     ------------------------------------------------------------------
C
C*          1.   CONVERT WIND IN KNOTS TO METER PER SECOND .
C                -------------------------------------------
 100  CONTINUE
C
C
      IA=INT(0.5148 * IA +0.5)
      RETURN
      END
      FUNCTION P(Z)                             
C
      DATA A/5.252368255329/, B/44330.769230769/
      DATA  C/0.000157583169442/                
      DATA  PTRO/226.547172/, PO/1013.25/
C      
      IF (Z.GT.11000.) GO TO 50                 
      Y = 1.-Z/B                                
      P = PO*(Y**A)                             
      RETURN                                    
C
50    Y = -C*(Z-11000.)                         
      P = PTRO*EXP(Y)                           
      RETURN                                    
      END
      
      SUBROUTINE SAVBULL ( IERR )
C
C**** *SAVBULL*
C
C
C     PURPOSE.
C     --------
C
C         WRITE COMPLETE BULLETIN TO ERROR FILE .
C
C         BULLETIN IN KCHAR(1)-KCHAR(IGS) IN CCITT 5.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVBULL(IERR)*
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
C
      CHARACTER*80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
c     YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
      YGS=CHAR(03)//CHAR(01)//CHAR(13)//CHAR(13)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
c      IF(IERR .EQ. 0) RETURN
C
c
      ierr = 1
c
      YLINE=' '
      YLINEA=' '
C
C
C
	  open(unit=11,iostat=ios,err=400,
     C     FILE='AIRC.error.dat',status='UNKNOWN')
c
      IP = 1
      JP = IP
      J = IGS
C
C*          1.1  OUTPUT INITIAL CONTROL CHARACTERS.
C                ----------------------------------
 110  CONTINUE
C
      CALL NEXTPRT (JP,IGS)
      K = JP - IP
      N1 = 0
      DO 111 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127) THEN
                                   YLINEA(N1:N1)=Y63
                                   ISIGN=1
                                   KCHAR(IP)=KCHAR(IP).AND.127
                                          END IF
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
  111 CONTINUE
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
      YLINE=' '
      YLINEA=' '
C
 120  CONTINUE
C
      CALL NEXTPRT (IP,J)
      IF (IP .GT. J) GO TO 400
      JP = IP
      CALL NEXTEND (JP,J)
      CALL NEXTPRT (JP,J)
      K = JP - IP
      N1 = 0
      DO 112 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127 )
     C                      THEN
                               YLINEA(N1:N1) = Y63
                               ISIGN= 1
                               KCHAR(IP) = KCHAR(IP).AND.127
                            END IF
C
      YLINE(N1:N1) = CHAR(KCHAR(IP))
      IP = IP + 1
C
  112 CONTINUE
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
C
      YLINE=' '
      YLINEA=' '
C
      GO TO 120
C
 300  IERR = -1
      PRINT*,' ERROR IN WRITING INTO ERROR FILE IOS=',IOS 
 400  CONTINUE
C
      WRITE(11,'(A)') YGS
      CLOSE(11)
C
C     REMOVE PARITY BIT
C
      DO 410 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 410  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE SAVREP ( IHEAD,IERR)
C
C**** *SAVREP*
C
C
C     PURPOSE.
C     --------
C
C         WRITE REPORT IN ERROR TO THE ERROR FILE.
C
C                 IHEAD = 0 , WRITE BULLETIN HEADER AND ERROR REPORT
C                             TO ERROR FILE.
C                       = 1 , WRITE ERROR REPORT ONLY.
C                       = 2 , WRITE 'GS' CHARACTER AT END.
C
C                 IERR NOT USED.
C
C                 IHEAD SET TO 1 IF HEADER WRITTEN , OTHERWISE
C                       UNCHANGED.
C
C                 IERR SET TO -1 , IF ERROR IN WRITE , OTHERWISE
C                       UNCHANGED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *SAVREP(IHEAD,IERR)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'comindx.h'
      INCLUDE 'combuff.h'
C
      DIMENSION ISTART(4),IFIN(4)
C
      CHARACTER *80 YLINE,YLINEA
      CHARACTER*1 Y63
      CHARACTER*4 YGS
C
      Y63=CHAR(63)
c     YGS=CHAR(13)//CHAR(13)//CHAR(10)//CHAR(29)
      ygs=char(03)//char(01)//char(13)//char(13)
C     ------------------------------------------------------------------
C*          1.   OPEN ERROR FILE AT THE BEGINNING OF THE PROCESS.
C                -------------------------------------------------
 100  CONTINUE
C
c      IF(IERR .EQ. 0) RETURN
C
c
      ierr = 1
c
      YLINE=' '
      YLINEA=' '
C
C
C
      OPEN(UNIT=11,IOSTAT=IOS,ERR=400,
     C     FILE='AIRC.error.dat',
     C     ACCESS='APPEND',
     c     STATUS='UNKNOWN',
     C     RECL=80                      )
C
C
C
C*          1.2  WRITE BULLETIN HEADER TO ERROR
C                ------------------------------
C                FILE IF NOT ALREADY DONE.
C                -------------------------
 120  CONTINUE
C
      IF ( IHEAD.NE.0 ) GO TO 130
C
C
      ISTART(1) = 1
      ISTART(2) = ISL
      ISTART(3) = IAH
      ISTART(4) = IMI
C
      IFIN(1) = ISL
      IFIN(2) = IAH
      IFIN(3) = JAH
      CALL NEXTEND(IFIN(3),IGS)
      CALL NEXTPRT(IFIN(3),IGS)
      IFIN(4) = JMI
      CALL NEXTEND(IFIN(4),IGS)
      CALL NEXTPRT(IFIN(4),IGS)
C
      IP = 0
      N2 = 0
C
      IHEAD = 1
C
      NN = 4
C
      DO 121 N=1,NN
         K = IFIN(N) - ISTART(N) 
         if(k.gt.80) k=80
         DO 122 N1=1,K
            N2 = N2 + 1
            IP = IP + 1
            IF (KCHAR(IP).GT.127)
     C                      THEN
                                YLINEA(N2:N2) = Y63
                                ISIGN=1
                                KCHAR(IP)=KCHAR(IP).AND.127
                            END IF
C
            YLINE(N2:N2) = CHAR(KCHAR(IP))
C
  122    CONTINUE
c
         if(k.le.2) go to 18
c
C
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N2)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N2)
         ISIGN=0
      END IF
C
 18   continue
c
         YLINE=' '
         YLINEA=' '
C
      N2 = 0
C
  121 CONTINUE
C
C
C*           1.3   WRITE ERROR REPORT , IF REQUIRED.
C***               ---------------------------------
 130  CONTINUE
C
      IF ( IHEAD.EQ.2 ) GO TO 140
C
C
C     AVOID WRITING REPORT TWICE IF MIMIMJMJ  LINE IS
C     MISSING.
C
      IF ( IAH.EQ.KPT ) THEN
           CLOSE(11)
           RETURN
      END IF
C
C     AVOID WRITING MIMIMJMJ TWICE ( CORRUPT MIMIMJMJ CAN BE TAKEN
C     AS STATION NUMBER )
C
      IF ( KPT.LT.IFIN(4) ) KPT = IFIN(4)
C
C
      IP = KPT
      IF(KDEC(4) .EQ. 35 .OR. KDEC(4) .EQ. 36) IP = IMI
      IF(KDEC(4) .EQ. 32 .OR. KDEC(4) .EQ. 33) IP = IMI
      J = IEQ+ 3
      IF ( J.GT.IGS) J = IGS
C
  133 CALL NEXTPRT (IP,J)
      IF (IP.GT.J) THEN
          CLOSE(11)
          RETURN
      END IF 
      JP = IP
      CALL NEXTEND(JP,J)
      CALL NEXTPRT(JP,J)
      K = JP - IP
      if(k.gt.80) k=80
      N1 = 0
      DO 131 N=1,K
         N1 = N1 + 1
         IF ( KCHAR(IP).GT.127)
     C                        THEN
                                  YLINEA(N1:N1) = Y63
                                  ISIGN= 1
                                  KCHAR(IP) = KCHAR(IP).AND.127
                              END IF
C
         YLINE(N1:N1) = CHAR(KCHAR(IP))
         IP = IP + 1
C
 131  CONTINUE
c
      if(k.le.2) go to 19
c 
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:N1)
      IF(ISIGN.EQ.1) THEN
         WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINEA(1:N1)
         ISIGN=0
      END IF
C
 19   continue
c
      YLINE=' '
      YLINEA=' '
C
C
      GO TO 133
C
C
C*              1.4 WRITE 'GS' AT END OF BULLETIN.
C                   ------------------------------
 140  CONTINUE
C
      YLINE(1:4)= YGS
C
      WRITE (11,'(A)',ERR=300,IOSTAT=IOS) YLINE(1:4)
      CLOSE(11)
C
      GO TO 400
C     ----------------------------------------------------------------
 300  IERR = -1
      PRINT*,' ERROR IN WRITING INTO ERROR FILE IOS=',IOS 
C     ----------------------------------------------------------------
 400  CONTINUE
C
C     REMOVE PARITY BIT
C
      DO 500 I = 1 , IGS
      KCHAR(I) = KCHAR(I) .AND. 127
 500  CONTINUE
C
      RETURN
      END
      
      SUBROUTINE DATUM(IDD,IMM,IYY)
C
C**** *DATUM*
C
C
C     PURPOSE.
C     --------
C         DEFINE PROPER MONTH AND YEAR IF DAY IS DEFINED.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *DATUM(IDD,IMM,IYY)*
C
C                       IDD - DAY
C                       IMM - MONTH
C                       IYY - YEAR
C
C     METHOD.
C     -------
C
C          IF IDD IS GREATER THAN CURRENT DAY DAY IS CONSIDERED TO BE FROM
C          PREVIOUS MONTH.IF CURRENT MONTH IS JANUARY
C          YEAR BECOMS PREVIOUS ONE.
C          IF IDD IS LESS OR EQUALL THAN CURRENT DAY IT IS FROM CURRENT MONTH
C          AND YEAR.
C
C
C
C     EXTERNALS.
C     ----------
C
C         *CALL* *DATIM(YDATE)*
C
C
C     MODIFICATIONS.
C     --------------
C
C	   M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
      
      include 'comdate.h'
C      
      CHARACTER*3 YMONTH(12)
      integer iyear,imonth,iday,iutc,ihour,imin,isec,imili 
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C
C     ------------------------------------------------------------------
C
C*          1.   GET DATE FROM THE SYSTEM.
C                -------------------------
 100  CONTINUE
C
c       CALL datim(iyear,imonth,iday,iutc,ihour,imin,isec,imili)
       iyear = ny
       imonth = nm
       iday = nd
       ihour = nh
       imin = nmin
       isec = nsec
c       print*,'data=',iyear,imonth,iday,ihour,imin,isec
C
C
C*          1.1  DEFINE MONTH AND YEAR
C                ---------------------
 110  CONTINUE
C
      IF(IDAY.GE.IDD) THEN
                         IMM=IMONTH
                         IYY=IYEAR
                         ima=imonth
                         RETURN
                      END IF
C
      IF(IDAY.LT.IDD) THEN
                         IF(IMONTH.EQ.1) THEN
                                            IMM=12
                                            IYY=IYEAR-1
                                            RETURN
                                         END IF
                         IMM=IMONTH-1
                         IYY=IYEAR
                      END IF
C
      RETURN
      END
      
      SUBROUTINE datim(date_time)
C
C     This subroutine returns a interger array (8)
C       where:  value1 = 4-digit year
c		value2 = month of the year
c		value3 = day of the year
c		value4 = time difference to UTC in minutes.
c		value5 = hour of the day ( range 0 to 23)
c		value6 = minutes of the hour ( range 0 to 59)
c		value7 = seconds of the range ( range 0 to 59)
c		value8 = miliseconds of the second ( range 0 to 999)		
C     
      include 'comdate.h'
      integer date_time (8)
      character*12  real_clock(3)
      CHARACTER*3 YMONTH(12)      
C
      DATA YMONTH/'Jan','Feb','Mar','Apr','May','Jun','Jul',
     1            'Aug','Sep','Oct','Nov','Dec'/
C----------------------------------------------------------------
C    Caso seja fornecido um argumento sera usado caso contrario
C    pegara a data do sistema
C----------------------------------------------------------------
               integer k,iargc
               CHARACTER*12 arg
               external getarg,iargc
               k=iargc()
               call getarg(k , arg)
               
      if (k .lt. 1 )   then      
               
 	CALL date_and_time(real_clock(1),real_clock(2),real_clock(3),
     c   date_time)	 
      else
c            PRINT*,'Passando a data'
             read(arg(1:4),'(i4.4)') ny
             read(arg(5:6),'(i2.2)') nm
             read(arg(7:8),'(i2.2)') nd
             read(arg(9:10),'(i2.2)') nh
             read(arg(11:12),'(i2.2)') nmin
             nutc = 0
             nsec = 0
             ncc = 0
             date_time(1) = ny
             date_time(2) = nm
             date_time(3) = nd
             date_time(4) = nutc
             date_time(5) = nh
             date_time(6) = nmin
             date_time(7) = nsec
             date_time(8) = ncc
            
      end if
             ny = date_time(1)
             nm = date_time(2)
             nd = date_time(3) 
             nutc = date_time(4) 
             nh = date_time(5)
             nmin = date_time(6)
             nsec = date_time(7)
             ncc = date_time(8)
c       print*,ny,nm,nd,nutc,NH,NMIN,NSEC,ncc             
C----------------------------------------------------------------
      RETURN
      END
      
      SUBROUTINE GETNEXT( IERR )
C
C**** *GETNEXT*
C
C
C     PURPOSE.
C     --------
C         GET NEXT MESSAGE FROM MDB.
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *GETNEXT( IERR )*
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       15/09/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
      INCLUDE 'combuff.h'
      INCLUDE 'compoin.h'
      INCLUDE 'comstat.h'
      INCLUDE 'comwt.h'
      INCLUDE 'comkey.h'
      include 'comdate.h'
C
C
      character*4 cstream
      character*15000 ychar
      character*25 ytime
      CHARACTER*17 CTSTAMP
      character*78 cstr
c
      data cstr/'                   airep decoding'/
C
      DATA NSKIP/0/
C     ------------------------------------------------------------------
C*          1.   RESET ERROR INDICATOR, WORD AND BIT POINTERS.
C                ---------------------------------------------
 100  CONTINUE
C
      IERR=0
      NWPT=1
      NBPT=0
      NSUB=0
      ilenby=0
      ychar=' '
C
C
c                write last time stamp processed.
c
      if (ostream) then 
c         call datim(ny,nmonth,nday,iutc,NHOUR,NMINUTE,NSECOND,icc)
         nmonth = nm
         nday = nd
         nhour = nh
         nminute = nmin
         nsecond = nsec
         WRITE(YTIME,'(i4.4,5I2.2)',IOSTAT=IOS,ERR=410)
     1       NY,NMONTH,NDAY,NHOUR,NMINUTE,NSECOND
         
         WRITE(17,9906,IOSTAT=IOS,ERR=410)
     1      CSTR,CSTREAM,CTSTAMP,YTIME
C
         REWIND(17)
c         
      end if
      go to 110
c
 410  continue
c
 101  print*,' Error writing time stamp.'
C
 9906 FORMAT(1h ,A,
     1     //1h ,'stream             ',A,
     1      /1h ,'time stamp         ',a,
     1     //1h ,'last time updated  ',a  )
c
C
C           1.1  GET NEXT MESSAGE.
C                -----------------
 110  CONTINUE
      ostream=.true.
      ILEN=ILENBY
c      print*,'Current time stamp is ',ctstamp(1:20)
C
      READ(CTSTAMP,'(6x,4i2)') NRDAY,NRHOUR,
     1                         NRMIN,NRSEC
c
 115  continue      
 
      NUMBULL=NUMBULL+1 
C
C
C           1.2  PRINT BULLETIN NUMBER.
C                ----------------------
 120  CONTINUE
C
c      WRITE(*,9902) NUMBULL
C
C
C           1.3  SKIP BULLETIN IF NECESSARY.
C                ---------------------------
 130  CONTINUE
C
C      IF(NUMBULL.EQ.NSKIP) GO TO 110
C
C
C           1.4  TRANSFER BULLETIN TO 'KCHAR' ONE CHARACTER PER WORD.
C                ----------------------------------------------------
C                AND SUPPRESS PARITY BIT.
C                ------------------------
 140  CONTINUE
C
      DO 141 I=1,ILEN
C
      KCHAR(I)=ICHAR(YCHAR(I:I)).AND.127
C
 141  CONTINUE
C      
      RETURN
C
C     -----------------------------------------------------------------
 400  CONTINUE
C
 9901 FORMAT(1H ,' + + + ERROR GETTING NEXT MESSAGE FROM MDB + + +',I6)
 9902 FORMAT(1H ,' BULLETIN NUMBER = ',I9)
C
      END
      
      SUBROUTINE NXMIMJ(I,J,II)
C
C**** *NXMIMJ*
C
C
C     PURPOSE.
C     --------
C
C         TO FIND NEXT MIMIMJMJ GROUP IN THE BULLETIN.
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT GROUP OF
C         ('TTAA' OR 'TTBB' OR 'TTCC' OR 'TTDD' ETC.)
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXTMI(I,J,II)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C
C         OUTPUT    : II- POSITION OF THE FIRST CHARACTER
C                         IN REQUIRED GROUP
C                         IF CHARACTER NOT FOUND II = 99999
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
      DIMENSION MIMJ(26)
C
      CHARACTER*4 YMIMJ
C
      DATA MIMJ /65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
     &           80,81,82,83,84,85,86,87,88,89,90/
C     ------------------------------------------------------------------
C*          1.   FIND NEXT MIMIMJMJ GROUP.
C                -------------------------
 100  CONTINUE
C
C
      II=9999
      K =IABS(I)
      M =IABS(I)
C
 101  CONTINUE
C
      CALL NEXSEP2(M,J,*1000)
      CALL NEXPRT2(M,J,*1000)
C
      IF(M.GE.J) RETURN
C
      YMIMJ=CHAR(KCHAR(M  ))//CHAR(KCHAR(M+1))//CHAR(KCHAR(M+2))//
     1      CHAR(KCHAR(M+3))
C
      
      ISTART=0
      IF(YMIMJ(1:4).EQ.'ARP ') ISTART=1 
      IF(YMIMJ(1:4).EQ.'ARS ') ISTART=1 
      IF(YMIMJ(1:4).EQ.'AIR ') ISTART=1 
      IF(YMIMJ(1:4).EQ.'LVR ') ISTART=1 
      IF(YMIMJ(1:4).EQ.'ASC ') ISTART=1 
      IF(YMIMJ(1:4).EQ.'DES ') ISTART=1 
      IF(YMIMJ(1:4).EQ.'LVW ') ISTART=1
C
      IF(ISTART.EQ.1) THEN
         CALL PRESEP(M,K,*1000)
         CALL PREPRT(M,K,*1000)
         II= M+1
         RETURN
      END IF
C
C
       GO TO 101
C
 1000 CONTINUE
C
      RETURN
      END
      
      SUBROUTINE PRESEP ( I,J,*)
C
C**** *PRESEP*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PRESEP(I,J,*)
C
C                 INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                             J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C                 OUTPUT    : I - POSITION OF PREVIOUS 'CR' OR 'LF' OR 'S
C                                 IF NO CHARACTER FOUND THE CONTROL RETUR
C                                 ALTERNATIVE RETURN POINT *
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   LOCATE THE PREVIOUS GROUP BY FINDING THE NEXT
C                ---------------------------------------------
C                CHARACTER WHICH IS 'CR' OR 'LF' OR 'SPACE'.
C                --------------------------------------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE PREPRT(I,J,*)
C
C**** *PREPRT*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR PREVIOUS CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *PREPRT(I,J,*)*
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C
C     MODIFICATIONS.
C     --------------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C		R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.   SCAN BULLETIN.
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J,-1
         IF(I .LE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXPRT2(I,J,*)
C
C**** *NEXPRT2*
C
C
C     PURPOSE.
C     --------
C
C         SCANS BULLETIN IN 'KCHAR' FOR NEXT CHARACTER WHICH
C         IS NOT 'SOH' , 'CR' , 'LF' , 'SPACE' OR 'GS' .
C
C         INPUT     : I - SCAN STARTS AT WORD I.
C                     J - SCAN STOPS AT WORD J .
C
C         OUTPUT    : I - POSITION OF REQUIRED CHARACTER.
C                         IF CHARACTER NOT FOUND THE CONROL
C                         RETURNS TO ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXPRT2(I,J,*)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C
C*          1.   SCAN BULLETIN.                    .
C                --------------
 100  CONTINUE
C
C     'SOH' = 1 , 'LF' = 10 , 'CR' = 13 , SPACE = 32 , 'GS' = 29.
C
      I = IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I).AND.127
         IF ( KAR.NE.1.AND.KAR.NE.10.AND.KAR.NE.13.
     C            AND.KAR.NE.32.AND.KAR.NE.29) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE NEXSEP2 ( I,J,*)
C
C**** *NEXSEP2*
C
C
C     PURPOSE.
C     --------
C
C         LOCATE THE NEXT GROUP BY FINDING THE NEXT
C         CHARACTER WHICH IS NOT 'CR' OR 'LF' OR 'SPACE'.
C         'CR' OR 'LF' OR 'SPACE'
C
C         INPUT     : I - SCAN STARTS AT WORD 'I' OF 'KCHAR' .
C                     J - SCAN ENDS AT WORD 'J' OF 'KCHAR' .
C
C         OUTPUT    : I - POSITION OF NEXT 'CR' OR 'LF' OR 'SPACE' CHARACTER
C                         IF NO CHARACTER FOUND THE CONTROL RETURN TO
C                         ALTERNATIVE RETURN POINT *
C
C**   INTERFACE.
C     ----------
C
C         *CALL* *NEXSEP2(I,J,*)*
C
C     AUTHOR.
C     -------
C
C          M. DRAGOSAVAC    *ECMWF*       AUG 1988.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
      INCLUDE 'parameter.h'
      INCLUDE 'comwork.h'
C
C     ------------------------------------------------------------------
C*          1.  SCAN BULLETIN.                     .
C                -------------
 100  CONTINUE
C
C
C     'CR' = 13 , 'LF' = 10 , 'SPACE' = 32.
C
      I=IABS(I)
      K = I
      DO 101 I=K,J
         IF(I .GE. J) RETURN 1
         KAR = KCHAR(I) .AND. 127
         IF(KAR .EQ. 13 .OR. KAR .EQ. 10 .OR. KAR .EQ. 32) RETURN
  101 CONTINUE
C
      RETURN 1
      END
      
      SUBROUTINE OCTNUM(KWPTB,KBPTB)
C
C**** *OCTNUM*
C
C
C     PURPOSE.
C     --------
C             CALCULATE NUMBER OF OCTETS FROM BIT POSITION DEFINED BY
C     KWPT,KBPT  AND KWPTB,KBPTB; NUMBER OF OCTETS MUST BE EVEN. IF IT IS
C     NEEDED PADING WITH 0 BIT PERFORMS. NUMBER OF OCTETS IS WRITTEN AT
C     BEGINIG OF THE SECTION.
C
C**   INTERFACE.
C     ----------
C
C          *CALL* *OCTNUM(KWPTB,KBPTB)*
C
C
C     EXTERNALS.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KBPW*  - NUMBER OF BITS IN COMPUTER WORD.
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KWPT*  - POINTER TO WORD IN KD ARRAY.
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C      *CALL* *SBYTE(KD,KS,KSKIP,KSIZE)
C
C             *KD*    - DESTINATION
C             *KS*    - SOURCE
C             *KSKIP* - NUMBER OF BITS TO BE SKIPPED
C             *KSIZE* - BIT LENGTH
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       07/10/87.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      INCLUDE 'parameter.h'
      INCLUDE 'compoin.h'
C     ------------------------------------------------------------------
C*          1.    CALCULATE NUMBER OF OCTETS.
C                 ---------------------------
 100  CONTINUE
C
      IB   =(NWPT-1) * NBPW + NBPT
      IBB  =(KWPTB-1)* NBPW + KBPTB
C
      IDIFB= IB - IBB
C
      NOCT = IDIFB/8
      IBDW = IDIFB - NOCT*8
C
      IF(IBDW .NE.0)THEN
                       NOCT=NOCT+1
                       IBDW=8-IBDW
                       CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
                    END IF
C
C     ------------------------------------------------------------------
C*          2.  CHECK IF THERE ARE EVEN NUMBER OF OCTETS IN BLOCK.
C               --------------------------------------------------
 200  CONTINUE
C
      IF(MOD(NOCT,2).NE.0) THEN
          IBDW = 8
          CALL PACK(NBPW,MBUF(NWPT),0,NWPT,NBPT,IBDW )
          NOCT = NOCT+1
      END IF
C     ------------------------------------------------------------------
C*          3.  WRITE NUMBER OF OCTETS AT BEGINING OF BLOCK.
C               --------------------------------------------
 300  CONTINUE
C
      IBDW  = 24
      CALL SBYTE(MBUF(KWPTB),NOCT,KBPTB,IBDW)
C
      RETURN
      END
      
      SUBROUTINE PACK(KBPW,KD,KS,KWPT,KBPT,KSI)
C
C**** *PACK*
C
C
C     PURPOSE.
C     --------
C            PURPOSE OF THIS ROUTINE IS TO PACK VALUE *KS* IN
C         *KSI* BITS, STARTED AT WORD KWPT OF ARRAY *KD* AFTER
C         SKIPPING NBPT BITS.  AT THE END
C         POINTERS *NWPT* AND *NBPT* ARE ADJUSTED.
C
C**   INTERFACE.
C     ----------
C
C     *CALL* *PACK(KBPW,KD,KS,KWPT,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     EXTERNALS.
C     ----------
C
C
C            *CALL SBYTE(KD,KS,KBPT,KSI)*
C
C            *KD*    - DESTINATION ARRAY.
C            *KS*    - SOURCE
C            *KBPT*  - POINTER TO BIT IN THE KD(KWPT)
C            *KSI*   - NUMBER OF BITS ACCUPIED BY KS.
C
C
C     AUTHOR.
C     -------
C
C          M. D. DRAGOSAVAC    *ECMWF*       09/06/86.
C
C
C     MODIFICATIONS.
C     --------------
C
C          R.CINTRA   *CPTEC*
C
C
      IMPLICIT LOGICAL(O,G), CHARACTER*8(C,H,Y)
C
C
      DIMENSION KD(*)
C
C     ------------------------------------------------------------------
C*          1.   SET UP BIT PATTERN.
C                -------------------
C
 100  CONTINUE
C
      CALL SBYTE(KD,KS,KBPT,KSI)
C
C     ------------------------------------------------------------------
C*          1.1  UPDATE WORD AND BIT POINTERS.
C                -----------------------------
 110  CONTINUE
C
      KBPT = KBPT + KSI
C
      IF(KBPT.GE.KBPW) THEN
                          KW  = KBPT/ KBPW
                          KBPT= KBPT - KW * KBPW
                          KWPT= KWPT +KW
                       END IF
C
      RETURN
      END
C
